/* Enclosure.c generated by valac 0.38.8, the Vala compiler
 * generated from Enclosure.vala, do not modify */

/*This file is part of FeedReader.*/
/**/
/*FeedReader is free software: you can redistribute it and/or modify*/
/*it under the terms of the GNU General Public License as published by*/
/*the Free Software Foundation, either version 3 of the License, or*/
/*(at your option) any later version.*/
/**/
/*FeedReader is distributed in the hope that it will be useful,*/
/*but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*GNU General Public License for more details.*/
/**/
/*You should have received a copy of the GNU General Public License*/
/*along with FeedReader.  If not, see <http://www.gnu.org/licenses/>.*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>


#define FEED_READER_TYPE_ENCLOSURE (feed_reader_enclosure_get_type ())
#define FEED_READER_ENCLOSURE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FEED_READER_TYPE_ENCLOSURE, FeedReaderEnclosure))
#define FEED_READER_ENCLOSURE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FEED_READER_TYPE_ENCLOSURE, FeedReaderEnclosureClass))
#define FEED_READER_IS_ENCLOSURE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FEED_READER_TYPE_ENCLOSURE))
#define FEED_READER_IS_ENCLOSURE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FEED_READER_TYPE_ENCLOSURE))
#define FEED_READER_ENCLOSURE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FEED_READER_TYPE_ENCLOSURE, FeedReaderEnclosureClass))

typedef struct _FeedReaderEnclosure FeedReaderEnclosure;
typedef struct _FeedReaderEnclosureClass FeedReaderEnclosureClass;
typedef struct _FeedReaderEnclosurePrivate FeedReaderEnclosurePrivate;

#define FEED_READER_TYPE_ENCLOSURE_TYPE (feed_reader_enclosure_type_get_type ())
enum  {
	FEED_READER_ENCLOSURE_0_PROPERTY,
	FEED_READER_ENCLOSURE_NUM_PROPERTIES
};
static GParamSpec* feed_reader_enclosure_properties[FEED_READER_ENCLOSURE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

struct _FeedReaderEnclosure {
	GObject parent_instance;
	FeedReaderEnclosurePrivate * priv;
};

struct _FeedReaderEnclosureClass {
	GObjectClass parent_class;
};

typedef enum  {
	FEED_READER_ENCLOSURE_TYPE_IMAGE,
	FEED_READER_ENCLOSURE_TYPE_VIDEO,
	FEED_READER_ENCLOSURE_TYPE_AUDIO,
	FEED_READER_ENCLOSURE_TYPE_FILE
} FeedReaderEnclosureType;

struct _FeedReaderEnclosurePrivate {
	gchar* m_article_id;
	gchar* m_url;
	FeedReaderEnclosureType m_type;
};


static gpointer feed_reader_enclosure_parent_class = NULL;

GType feed_reader_enclosure_get_type (void) G_GNUC_CONST;
GType feed_reader_enclosure_type_get_type (void) G_GNUC_CONST;
#define FEED_READER_ENCLOSURE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), FEED_READER_TYPE_ENCLOSURE, FeedReaderEnclosurePrivate))
FeedReaderEnclosure* feed_reader_enclosure_new (const gchar* article_id, const gchar* url, FeedReaderEnclosureType type);
FeedReaderEnclosure* feed_reader_enclosure_construct (GType object_type, const gchar* article_id, const gchar* url, FeedReaderEnclosureType type);
gchar* feed_reader_enclosure_get_url (FeedReaderEnclosure* self);
FeedReaderEnclosureType feed_reader_enclosure_get_enclosure_type (FeedReaderEnclosure* self);
static void feed_reader_enclosure_finalize (GObject * obj);


FeedReaderEnclosure* feed_reader_enclosure_construct (GType object_type, const gchar* article_id, const gchar* url, FeedReaderEnclosureType type) {
	FeedReaderEnclosure * self = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	FeedReaderEnclosureType _tmp4_;
	g_return_val_if_fail (article_id != NULL, NULL);
	g_return_val_if_fail (url != NULL, NULL);
	self = (FeedReaderEnclosure*) g_object_new (object_type, NULL);
	_tmp0_ = article_id;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->m_article_id);
	self->priv->m_article_id = _tmp1_;
	_tmp2_ = url;
	_tmp3_ = g_strdup (_tmp2_);
	_g_free0 (self->priv->m_url);
	self->priv->m_url = _tmp3_;
	_tmp4_ = type;
	self->priv->m_type = _tmp4_;
	return self;
}


FeedReaderEnclosure* feed_reader_enclosure_new (const gchar* article_id, const gchar* url, FeedReaderEnclosureType type) {
	return feed_reader_enclosure_construct (FEED_READER_TYPE_ENCLOSURE, article_id, url, type);
}


gchar* feed_reader_enclosure_get_url (FeedReaderEnclosure* self) {
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->m_url;
	_tmp1_ = g_strdup (_tmp0_);
	result = _tmp1_;
	return result;
}


FeedReaderEnclosureType feed_reader_enclosure_get_enclosure_type (FeedReaderEnclosure* self) {
	FeedReaderEnclosureType result = 0;
	FeedReaderEnclosureType _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->m_type;
	result = _tmp0_;
	return result;
}


static void feed_reader_enclosure_class_init (FeedReaderEnclosureClass * klass) {
	feed_reader_enclosure_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (FeedReaderEnclosurePrivate));
	G_OBJECT_CLASS (klass)->finalize = feed_reader_enclosure_finalize;
}


static void feed_reader_enclosure_instance_init (FeedReaderEnclosure * self) {
	self->priv = FEED_READER_ENCLOSURE_GET_PRIVATE (self);
}


static void feed_reader_enclosure_finalize (GObject * obj) {
	FeedReaderEnclosure * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FEED_READER_TYPE_ENCLOSURE, FeedReaderEnclosure);
	_g_free0 (self->priv->m_article_id);
	_g_free0 (self->priv->m_url);
	G_OBJECT_CLASS (feed_reader_enclosure_parent_class)->finalize (obj);
}


GType feed_reader_enclosure_get_type (void) {
	static volatile gsize feed_reader_enclosure_type_id__volatile = 0;
	if (g_once_init_enter (&feed_reader_enclosure_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (FeedReaderEnclosureClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) feed_reader_enclosure_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FeedReaderEnclosure), 0, (GInstanceInitFunc) feed_reader_enclosure_instance_init, NULL };
		GType feed_reader_enclosure_type_id;
		feed_reader_enclosure_type_id = g_type_register_static (G_TYPE_OBJECT, "FeedReaderEnclosure", &g_define_type_info, 0);
		g_once_init_leave (&feed_reader_enclosure_type_id__volatile, feed_reader_enclosure_type_id);
	}
	return feed_reader_enclosure_type_id__volatile;
}



