/* MediaPlayer.c generated by valac 0.38.8, the Vala compiler
 * generated from MediaPlayer.vala, do not modify */

/*This file is part of FeedReader.*/
/**/
/*FeedReader is free software: you can redistribute it and/or modify*/
/*it under the terms of the GNU General Public License as published by*/
/*the Free Software Foundation, either version 3 of the License, or*/
/*(at your option) any later version.*/
/**/
/*FeedReader is distributed in the hope that it will be useful,*/
/*but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*GNU General Public License for more details.*/
/**/
/*You should have received a copy of the GNU General Public License*/
/*along with FeedReader.  If not, see <http://www.gnu.org/licenses/>.*/

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gst/gst.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gst/pbutils/pbutils.h>
#include <cairo.h>


#define FEED_READER_TYPE_MEDIA_PLAYER (feed_reader_media_player_get_type ())
#define FEED_READER_MEDIA_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FEED_READER_TYPE_MEDIA_PLAYER, FeedReaderMediaPlayer))
#define FEED_READER_MEDIA_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FEED_READER_TYPE_MEDIA_PLAYER, FeedReaderMediaPlayerClass))
#define FEED_READER_IS_MEDIA_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FEED_READER_TYPE_MEDIA_PLAYER))
#define FEED_READER_IS_MEDIA_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FEED_READER_TYPE_MEDIA_PLAYER))
#define FEED_READER_MEDIA_PLAYER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FEED_READER_TYPE_MEDIA_PLAYER, FeedReaderMediaPlayerClass))

typedef struct _FeedReaderMediaPlayer FeedReaderMediaPlayer;
typedef struct _FeedReaderMediaPlayerClass FeedReaderMediaPlayerClass;
typedef struct _FeedReaderMediaPlayerPrivate FeedReaderMediaPlayerPrivate;

#define FEED_READER_TYPE_MEDIA_TYPE (feed_reader_media_type_get_type ())

#define FEED_READER_TYPE_DISPLAY_POSITION (feed_reader_display_position_get_type ())
enum  {
	FEED_READER_MEDIA_PLAYER_0_PROPERTY,
	FEED_READER_MEDIA_PLAYER_NUM_PROPERTIES
};
static GParamSpec* feed_reader_media_player_properties[FEED_READER_MEDIA_PLAYER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block30Data Block30Data;
#define __g_list_free__g_object_unref0_0(var) ((var == NULL) ? NULL : (var = (_g_list_free__g_object_unref0_ (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))
typedef struct _feed_reader_media_player_inspectMediaData feed_reader_media_player_inspectMediaData;
typedef struct _Block31Data Block31Data;
enum  {
	FEED_READER_MEDIA_PLAYER_LOADED_SIGNAL,
	FEED_READER_MEDIA_PLAYER_NUM_SIGNALS
};
static guint feed_reader_media_player_signals[FEED_READER_MEDIA_PLAYER_NUM_SIGNALS] = {0};

struct _FeedReaderMediaPlayer {
	GtkBox parent_instance;
	FeedReaderMediaPlayerPrivate * priv;
};

struct _FeedReaderMediaPlayerClass {
	GtkBoxClass parent_class;
};

typedef enum  {
	FEED_READER_MEDIA_TYPE_VIDEO,
	FEED_READER_MEDIA_TYPE_AUDIO
} FeedReaderMediaType;

typedef enum  {
	FEED_READER_DISPLAY_POSITION_ALL,
	FEED_READER_DISPLAY_POSITION_POS,
	FEED_READER_DISPLAY_POSITION_LEFT
} FeedReaderDisplayPosition;

struct _FeedReaderMediaPlayerPrivate {
	GstElement* m_player;
	GtkWidget* m_videoWidget;
	GtkStack* m_playStack;
	GtkButton* m_playButton;
	GtkSpinner* m_playSpinner;
	GtkButton* m_muteButton;
	GtkButton* m_closeButton;
	GtkScale* m_scale;
	GtkButton* m_labelButton;
	GtkLabel* m_bufferLabel;
	gint m_margin;
	GtkImage* m_playIcon;
	GtkImage* m_pauseIcon;
	GtkImage* m_muteIcon;
	GtkImage* m_noiseIcon;
	GtkImage* m_closeIcon;
	gboolean m_muted;
	gdouble m_aspectRatio;
	guint m_seek_source_id;
	FeedReaderMediaType m_type;
	gchar* m_URL;
	FeedReaderDisplayPosition m_display;
};

struct _Block30Data {
	int _ref_count_;
	FeedReaderMediaPlayer* self;
	GSourceFunc callback;
	gpointer callback_target;
	GDestroyNotify callback_target_destroy_notify;
	gpointer _async_data_;
};

struct _feed_reader_media_player_inspectMediaData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FeedReaderMediaPlayer* self;
	Block30Data* _data30_;
	GThreadFunc run;
	void* run_target;
	GDestroyNotify run_target_destroy_notify;
	GThread* _tmp0_;
	GThread* _tmp1_;
};

struct _Block31Data {
	int _ref_count_;
	FeedReaderMediaPlayer* self;
	gdouble startValue;
};


static gpointer feed_reader_media_player_parent_class = NULL;

GType feed_reader_media_player_get_type (void) G_GNUC_CONST;
GType feed_reader_media_type_get_type (void) G_GNUC_CONST;
GType feed_reader_display_position_get_type (void) G_GNUC_CONST;
#define FEED_READER_MEDIA_PLAYER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), FEED_READER_TYPE_MEDIA_PLAYER, FeedReaderMediaPlayerPrivate))
FeedReaderMediaPlayer* feed_reader_media_player_new (const gchar* url);
FeedReaderMediaPlayer* feed_reader_media_player_construct (GType object_type, const gchar* url);
static void feed_reader_media_player_inspectMedia (FeedReaderMediaPlayer* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void feed_reader_media_player_inspectMedia_finish (FeedReaderMediaPlayer* self, GAsyncResult* _res_);
static void __lambda96_ (FeedReaderMediaPlayer* self, GObject* obj, GAsyncResult* res);
static void feed_reader_media_player_buildUI (FeedReaderMediaPlayer* self);
static void ___lambda96__gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self);
static void feed_reader_media_player_inspectMedia_data_free (gpointer _data);
static gboolean feed_reader_media_player_inspectMedia_co (feed_reader_media_player_inspectMediaData* _data_);
static Block30Data* block30_data_ref (Block30Data* _data30_);
static void block30_data_unref (void * _userdata_);
static gboolean _feed_reader_media_player_inspectMedia_co_gsource_func (gpointer self);
static void* __lambda95_ (Block30Data* _data30_);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
void feed_reader_logger_error (const gchar* message);
static gpointer ___lambda95__gthread_func (gpointer self);
static void feed_reader_media_player_onAllocation (FeedReaderMediaPlayer* self, GtkAllocation* allocation);
static void _feed_reader_media_player_onAllocation_gtk_widget_size_allocate (GtkWidget* _sender, GtkAllocation* allocation, gpointer self);
static gboolean feed_reader_media_player_busCallback (FeedReaderMediaPlayer* self, GstBus* bus, GstMessage* message);
static gboolean _feed_reader_media_player_busCallback_gst_bus_func (GstBus* bus, GstMessage* message, gpointer self);
static gboolean __lambda97_ (FeedReaderMediaPlayer* self);
static void feed_reader_media_player_calcTime (FeedReaderMediaPlayer* self);
static gboolean ___lambda97__gsource_func (gpointer self);
static void feed_reader_media_player_togglePause (FeedReaderMediaPlayer* self);
static void _feed_reader_media_player_togglePause_gtk_button_clicked (GtkButton* _sender, gpointer self);
#define FEED_READER_MEDIA_BUTTON_PLAY "Play"
#define FEED_READER_MEDIA_BUTTON_MUTE "Mute"
static void feed_reader_media_player_toggleMute (FeedReaderMediaPlayer* self);
static void _feed_reader_media_player_toggleMute_gtk_button_clicked (GtkButton* _sender, gpointer self);
static void __lambda98_ (FeedReaderMediaPlayer* self);
void feed_reader_media_player_kill (FeedReaderMediaPlayer* self);
static void ___lambda98__gtk_button_clicked (GtkButton* _sender, gpointer self);
#define FEED_READER_MEDIA_BUTTON_CLOSE "Close"
static gboolean feed_reader_media_player_valueChanged (FeedReaderMediaPlayer* self, GtkScrollType scroll, gdouble new_value);
static gboolean _feed_reader_media_player_valueChanged_gtk_range_change_value (GtkRange* _sender, GtkScrollType scroll, gdouble new_value, gpointer self);
static void feed_reader_media_player_switchDisplay (FeedReaderMediaPlayer* self);
static void _feed_reader_media_player_switchDisplay_gtk_button_clicked (GtkButton* _sender, gpointer self);
#define FEED_READER_MEDIA_BUTTON_PAUSE "Pause"
static gdouble* _double_dup (gdouble* self);
static Block31Data* block31_data_ref (Block31Data* _data31_);
static void block31_data_unref (void * _userdata_);
static gboolean ___lambda99_ (Block31Data* _data31_);
static void feed_reader_media_player_seek (FeedReaderMediaPlayer* self, gdouble new_value);
static gboolean ____lambda99__gsource_func (gpointer self);
#define FEED_READER_MEDIA_BUTTON_UNMUTE "Unmute"
static void feed_reader_media_player_finalize (GObject * obj);


static void __lambda96_ (FeedReaderMediaPlayer* self, GObject* obj, GAsyncResult* res) {
	GAsyncResult* _tmp0_;
	g_return_if_fail (res != NULL);
	feed_reader_media_player_buildUI (self);
	g_signal_emit (self, feed_reader_media_player_signals[FEED_READER_MEDIA_PLAYER_LOADED_SIGNAL], 0);
	_tmp0_ = res;
	feed_reader_media_player_inspectMedia_finish (self, _tmp0_);
}


static void ___lambda96__gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self) {
	__lambda96_ ((FeedReaderMediaPlayer*) self, source_object, res);
	g_object_unref (self);
}


FeedReaderMediaPlayer* feed_reader_media_player_construct (GType object_type, const gchar* url) {
	FeedReaderMediaPlayer * self = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_val_if_fail (url != NULL, NULL);
	self = (FeedReaderMediaPlayer*) g_object_new (object_type, NULL);
	self->priv->m_type = FEED_READER_MEDIA_TYPE_AUDIO;
	_tmp0_ = url;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->m_URL);
	self->priv->m_URL = _tmp1_;
	feed_reader_media_player_inspectMedia (self, ___lambda96__gasync_ready_callback, g_object_ref (self));
	return self;
}


FeedReaderMediaPlayer* feed_reader_media_player_new (const gchar* url) {
	return feed_reader_media_player_construct (FEED_READER_TYPE_MEDIA_PLAYER, url);
}


static void feed_reader_media_player_inspectMedia_data_free (gpointer _data) {
	feed_reader_media_player_inspectMediaData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (feed_reader_media_player_inspectMediaData, _data_);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void feed_reader_media_player_inspectMedia (FeedReaderMediaPlayer* self, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	feed_reader_media_player_inspectMediaData* _data_;
	FeedReaderMediaPlayer* _tmp0_;
	_data_ = g_slice_new0 (feed_reader_media_player_inspectMediaData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, feed_reader_media_player_inspectMedia_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	feed_reader_media_player_inspectMedia_co (_data_);
}


static void feed_reader_media_player_inspectMedia_finish (FeedReaderMediaPlayer* self, GAsyncResult* _res_) {
	feed_reader_media_player_inspectMediaData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}


static Block30Data* block30_data_ref (Block30Data* _data30_) {
	g_atomic_int_inc (&_data30_->_ref_count_);
	return _data30_;
}


static void block30_data_unref (void * _userdata_) {
	Block30Data* _data30_;
	_data30_ = (Block30Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data30_->_ref_count_)) {
		FeedReaderMediaPlayer* self;
		self = _data30_->self;
		(_data30_->callback_target_destroy_notify == NULL) ? NULL : (_data30_->callback_target_destroy_notify (_data30_->callback_target), NULL);
		_data30_->callback = NULL;
		_data30_->callback_target = NULL;
		_data30_->callback_target_destroy_notify = NULL;
		_g_object_unref0 (self);
		g_slice_free (Block30Data, _data30_);
	}
}


static gboolean _feed_reader_media_player_inspectMedia_co_gsource_func (gpointer self) {
	gboolean result;
	result = feed_reader_media_player_inspectMedia_co (self);
	return result;
}


static void _g_object_unref0_ (gpointer var) {
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}


static inline void _g_list_free__g_object_unref0_ (GList* self) {
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
}


static void* __lambda95_ (Block30Data* _data30_) {
	FeedReaderMediaPlayer* self;
	void* result = NULL;
	GSourceFunc _tmp18_;
	void* _tmp18__target;
	GDestroyNotify _tmp18__target_destroy_notify;
	GError * _inner_error_ = NULL;
	self = _data30_->self;
	{
		GstDiscoverer* discoverer = NULL;
		GstDiscoverer* _tmp0_;
		GstDiscovererInfo* info = NULL;
		GstDiscoverer* _tmp1_;
		const gchar* _tmp2_;
		GstDiscovererInfo* _tmp3_;
		GstDiscovererInfo* _tmp4_;
		GList* _tmp5_;
		_tmp0_ = gst_discoverer_new ((GstClockTime) (10 * GST_SECOND), &_inner_error_);
		discoverer = _tmp0_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch27_g_error;
		}
		_tmp1_ = discoverer;
		_tmp2_ = self->priv->m_URL;
		_tmp3_ = gst_discoverer_discover_uri (_tmp1_, _tmp2_, &_inner_error_);
		info = _tmp3_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (discoverer);
			goto __catch27_g_error;
		}
		_tmp4_ = info;
		_tmp5_ = gst_discoverer_info_get_stream_list (_tmp4_);
		{
			GList* i_collection = NULL;
			GList* i_it = NULL;
			i_collection = _tmp5_;
			for (i_it = i_collection; i_it != NULL; i_it = i_it->next) {
				GstDiscovererStreamInfo* _tmp6_;
				GstDiscovererStreamInfo* i = NULL;
				_tmp6_ = _g_object_ref0 ((GstDiscovererStreamInfo*) i_it->data);
				i = _tmp6_;
				{
					GstDiscovererStreamInfo* _tmp7_;
					_tmp7_ = i;
					if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp7_, gst_discoverer_video_info_get_type ())) {
						GstDiscovererVideoInfo* v = NULL;
						GstDiscovererStreamInfo* _tmp8_;
						GstDiscovererVideoInfo* _tmp9_;
						GstDiscovererVideoInfo* _tmp10_;
						guint _tmp11_;
						GstDiscovererVideoInfo* _tmp12_;
						guint _tmp13_;
						_tmp8_ = i;
						_tmp9_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gst_discoverer_video_info_get_type (), GstDiscovererVideoInfo));
						v = _tmp9_;
						_tmp10_ = v;
						_tmp11_ = gst_discoverer_video_info_get_width (_tmp10_);
						_tmp12_ = v;
						_tmp13_ = gst_discoverer_video_info_get_height (_tmp12_);
						self->priv->m_aspectRatio = ((gdouble) _tmp11_) / ((gdouble) _tmp13_);
						self->priv->m_type = FEED_READER_MEDIA_TYPE_VIDEO;
						_g_object_unref0 (v);
					}
					_g_object_unref0 (i);
				}
			}
			__g_list_free__g_object_unref0_0 (i_collection);
		}
		_g_object_unref0 (info);
		_g_object_unref0 (discoverer);
	}
	goto __finally27;
	__catch27_g_error:
	{
		GError* e = NULL;
		GError* _tmp14_;
		const gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp14_ = e;
		_tmp15_ = _tmp14_->message;
		_tmp16_ = g_strconcat ("Unable discover_uri: ", _tmp15_, NULL);
		_tmp17_ = _tmp16_;
		feed_reader_logger_error (_tmp17_);
		_g_free0 (_tmp17_);
		_g_error_free0 (e);
	}
	__finally27:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp18_ = _data30_->callback;
	_tmp18__target = _data30_->callback_target;
	_tmp18__target_destroy_notify = _data30_->callback_target_destroy_notify;
	_data30_->callback = NULL;
	_data30_->callback_target = NULL;
	_data30_->callback_target_destroy_notify = NULL;
	g_idle_add_full (G_PRIORITY_HIGH_IDLE, _tmp18_, _tmp18__target, _tmp18__target_destroy_notify);
	result = NULL;
	return result;
}


static gpointer ___lambda95__gthread_func (gpointer self) {
	gpointer result;
	result = __lambda95_ (self);
	block30_data_unref (self);
	return result;
}


static gboolean feed_reader_media_player_inspectMedia_co (feed_reader_media_player_inspectMediaData* _data_) {
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_data30_ = g_slice_new0 (Block30Data);
	_data_->_data30_->_ref_count_ = 1;
	_data_->_data30_->self = g_object_ref (_data_->self);
	_data_->_data30_->_async_data_ = _data_;
	_data_->_data30_->callback = _feed_reader_media_player_inspectMedia_co_gsource_func;
	_data_->_data30_->callback_target = _data_;
	_data_->_data30_->callback_target_destroy_notify = NULL;
	_data_->run = ___lambda95__gthread_func;
	_data_->run_target = block30_data_ref (_data_->_data30_);
	_data_->run_target_destroy_notify = block30_data_unref;
	_data_->_tmp0_ = g_thread_new ("inspectMedia", _data_->run, _data_->run_target);
	_data_->_tmp1_ = _data_->_tmp0_;
	_g_thread_unref0 (_data_->_tmp1_);
	_data_->_state_ = 1;
	return FALSE;
	_state_1:
	;
	block30_data_unref (_data_->_data30_);
	_data_->_data30_ = NULL;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (g_task_get_completed (_data_->_async_result) != TRUE) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}


static void _feed_reader_media_player_onAllocation_gtk_widget_size_allocate (GtkWidget* _sender, GtkAllocation* allocation, gpointer self) {
	feed_reader_media_player_onAllocation ((FeedReaderMediaPlayer*) self, allocation);
}


static gboolean _feed_reader_media_player_busCallback_gst_bus_func (GstBus* bus, GstMessage* message, gpointer self) {
	gboolean result;
	result = feed_reader_media_player_busCallback ((FeedReaderMediaPlayer*) self, bus, message);
	return result;
}


static gboolean __lambda97_ (FeedReaderMediaPlayer* self) {
	gboolean result = FALSE;
	GstState state = 0;
	GstState pending = 0;
	GstElement* _tmp0_;
	GstState _tmp1_ = 0;
	GstState _tmp2_ = 0;
	GstState _tmp3_;
	_tmp0_ = self->priv->m_player;
	gst_element_get_state (_tmp0_, &_tmp1_, &_tmp2_, (GstClockTime) 1000);
	state = _tmp1_;
	pending = _tmp2_;
	_tmp3_ = state;
	if (_tmp3_ == GST_STATE_PLAYING) {
		gint64 pos = 0LL;
		gint64 dur = 0LL;
		GstElement* _tmp4_;
		gint64 _tmp5_ = 0LL;
		GstElement* _tmp6_;
		gint64 _tmp7_ = 0LL;
		gdouble position = 0.0;
		gint64 _tmp8_;
		gdouble duration = 0.0;
		gint64 _tmp9_;
		gdouble percent = 0.0;
		gdouble _tmp10_;
		gdouble _tmp11_;
		guint _tmp12_;
		_tmp4_ = self->priv->m_player;
		gst_element_query_position (_tmp4_, GST_FORMAT_TIME, &_tmp5_);
		pos = _tmp5_;
		_tmp6_ = self->priv->m_player;
		gst_element_query_duration (_tmp6_, GST_FORMAT_TIME, &_tmp7_);
		dur = _tmp7_;
		_tmp8_ = pos;
		position = ((gdouble) _tmp8_) / 1000000000;
		_tmp9_ = dur;
		duration = ((gdouble) _tmp9_) / 1000000000;
		_tmp10_ = position;
		_tmp11_ = duration;
		percent = (_tmp10_ * 100.0) / _tmp11_;
		_tmp12_ = self->priv->m_seek_source_id;
		if (_tmp12_ == ((guint) 0)) {
			GtkScale* _tmp13_;
			gdouble _tmp14_;
			_tmp13_ = self->priv->m_scale;
			_tmp14_ = percent;
			gtk_range_set_value ((GtkRange*) _tmp13_, _tmp14_);
		}
		feed_reader_media_player_calcTime (self);
	}
	result = TRUE;
	return result;
}


static gboolean ___lambda97__gsource_func (gpointer self) {
	gboolean result;
	result = __lambda97_ ((FeedReaderMediaPlayer*) self);
	return result;
}


static void _feed_reader_media_player_togglePause_gtk_button_clicked (GtkButton* _sender, gpointer self) {
	feed_reader_media_player_togglePause ((FeedReaderMediaPlayer*) self);
}


static void _feed_reader_media_player_toggleMute_gtk_button_clicked (GtkButton* _sender, gpointer self) {
	feed_reader_media_player_toggleMute ((FeedReaderMediaPlayer*) self);
}


static void __lambda98_ (FeedReaderMediaPlayer* self) {
	feed_reader_media_player_kill (self);
}


static void ___lambda98__gtk_button_clicked (GtkButton* _sender, gpointer self) {
	__lambda98_ ((FeedReaderMediaPlayer*) self);
}


static gboolean _feed_reader_media_player_valueChanged_gtk_range_change_value (GtkRange* _sender, GtkScrollType scroll, gdouble new_value, gpointer self) {
	gboolean result;
	result = feed_reader_media_player_valueChanged ((FeedReaderMediaPlayer*) self, scroll, new_value);
	return result;
}


static void _feed_reader_media_player_switchDisplay_gtk_button_clicked (GtkButton* _sender, gpointer self) {
	feed_reader_media_player_switchDisplay ((FeedReaderMediaPlayer*) self);
}


static void feed_reader_media_player_buildUI (FeedReaderMediaPlayer* self) {
	GstElement* gtksink = NULL;
	GstElement* _tmp0_;
	GstElement* _tmp1_;
	GtkWidget* _tmp2_;
	gint _tmp3_;
	GtkWidget* _tmp4_;
	gint _tmp5_;
	GtkWidget* _tmp6_;
	gint _tmp7_;
	GtkWidget* _tmp8_;
	GstElement* _tmp9_;
	GstElement* _tmp10_;
	GstElement* _tmp11_;
	GstElement* _tmp12_;
	GstElement* _tmp13_;
	const gchar* _tmp14_;
	GstBus* bus = NULL;
	GstElement* _tmp15_;
	GstBus* _tmp16_;
	GstBus* _tmp17_;
	GtkImage* _tmp18_;
	GtkImage* _tmp19_;
	GtkImage* _tmp20_;
	GtkImage* _tmp21_;
	GtkImage* _tmp22_;
	GtkButton* _tmp23_;
	GtkButton* _tmp24_;
	GtkImage* _tmp25_;
	GtkButton* _tmp26_;
	GtkButton* _tmp27_;
	GtkButton* _tmp28_;
	GtkButton* _tmp29_;
	GtkButton* _tmp30_;
	GtkSpinner* _tmp31_;
	GtkStack* _tmp32_;
	GtkStack* _tmp33_;
	GtkButton* _tmp34_;
	GtkStack* _tmp35_;
	GtkSpinner* _tmp36_;
	GtkStack* _tmp37_;
	GtkButton* _tmp38_;
	GtkButton* _tmp39_;
	GtkImage* _tmp40_;
	GtkButton* _tmp41_;
	GtkButton* _tmp42_;
	GtkButton* _tmp43_;
	GtkButton* _tmp44_;
	GtkButton* _tmp45_;
	GtkButton* _tmp46_;
	GtkButton* _tmp47_;
	GtkImage* _tmp48_;
	GtkButton* _tmp49_;
	GtkButton* _tmp50_;
	GtkButton* _tmp51_;
	GtkButton* _tmp52_;
	GtkButton* _tmp53_;
	GtkScale* _tmp54_;
	GtkScale* _tmp55_;
	GtkScale* _tmp56_;
	GtkScale* _tmp57_;
	GtkButton* _tmp58_;
	GtkButton* _tmp59_;
	GtkButton* _tmp60_;
	GtkStyleContext* _tmp61_;
	GtkButton* _tmp62_;
	GtkButton* _tmp63_;
	GtkButton* _tmp64_;
	GtkButton* _tmp65_;
	GtkBox* hBox = NULL;
	GtkBox* _tmp66_;
	GtkBox* _tmp67_;
	gint _tmp68_;
	GtkBox* _tmp69_;
	GtkStack* _tmp70_;
	GtkBox* _tmp71_;
	GtkButton* _tmp72_;
	GtkBox* _tmp73_;
	GtkScale* _tmp74_;
	GtkBox* _tmp75_;
	GtkButton* _tmp76_;
	GtkBox* _tmp77_;
	GtkButton* _tmp78_;
	GtkLabel* _tmp79_;
	GtkLabel* _tmp80_;
	GtkLabel* _tmp81_;
	GtkLabel* _tmp82_;
	GtkLabel* _tmp83_;
	GtkOverlay* bufferOverlay = NULL;
	GtkOverlay* _tmp84_;
	GtkOverlay* _tmp85_;
	GtkWidget* _tmp86_;
	GtkOverlay* _tmp87_;
	GtkLabel* _tmp88_;
	GtkStyleContext* _tmp89_;
	FeedReaderMediaType _tmp90_;
	GtkBox* _tmp92_;
	g_return_if_fail (self != NULL);
	_tmp0_ = gst_element_factory_make ("gtksink", "sink");
	if (_tmp0_ != NULL) {
		g_object_ref_sink (_tmp0_);
	}
	gtksink = _tmp0_;
	_tmp1_ = gtksink;
	g_object_get ((GObject*) _tmp1_, "widget", &self->priv->m_videoWidget, NULL);
	_tmp2_ = self->priv->m_videoWidget;
	_tmp3_ = self->priv->m_margin;
	gtk_widget_set_margin_start (_tmp2_, _tmp3_);
	_tmp4_ = self->priv->m_videoWidget;
	_tmp5_ = self->priv->m_margin;
	gtk_widget_set_margin_end (_tmp4_, _tmp5_);
	_tmp6_ = self->priv->m_videoWidget;
	_tmp7_ = self->priv->m_margin;
	gtk_widget_set_margin_top (_tmp6_, _tmp7_);
	_tmp8_ = self->priv->m_videoWidget;
	g_signal_connect_object (_tmp8_, "size-allocate", (GCallback) _feed_reader_media_player_onAllocation_gtk_widget_size_allocate, self, 0);
	_tmp9_ = gst_element_factory_make ("playbin", "player");
	if (_tmp9_ != NULL) {
		g_object_ref_sink (_tmp9_);
	}
	_g_object_unref0 (self->priv->m_player);
	self->priv->m_player = _tmp9_;
	_tmp10_ = self->priv->m_player;
	_tmp11_ = gtksink;
	g_object_set ((GObject*) _tmp10_, "video_sink", _tmp11_, NULL);
	_tmp12_ = self->priv->m_player;
	g_object_set ((GObject*) _tmp12_, "volume", 1.0, NULL);
	_tmp13_ = self->priv->m_player;
	_tmp14_ = self->priv->m_URL;
	g_object_set ((GObject*) _tmp13_, "uri", _tmp14_, NULL);
	_tmp15_ = self->priv->m_player;
	_tmp16_ = gst_element_get_bus (_tmp15_);
	bus = _tmp16_;
	_tmp17_ = bus;
	gst_bus_add_watch_full (_tmp17_, G_PRIORITY_LOW, _feed_reader_media_player_busCallback_gst_bus_func, g_object_ref (self), g_object_unref);
	g_timeout_add_full (G_PRIORITY_LOW, (guint) 500, ___lambda97__gsource_func, g_object_ref (self), g_object_unref);
	_tmp18_ = (GtkImage*) gtk_image_new_from_icon_name ("media-playback-start-symbolic", GTK_ICON_SIZE_LARGE_TOOLBAR);
	g_object_ref_sink (_tmp18_);
	_g_object_unref0 (self->priv->m_playIcon);
	self->priv->m_playIcon = _tmp18_;
	_tmp19_ = (GtkImage*) gtk_image_new_from_icon_name ("media-playback-pause-symbolic", GTK_ICON_SIZE_LARGE_TOOLBAR);
	g_object_ref_sink (_tmp19_);
	_g_object_unref0 (self->priv->m_pauseIcon);
	self->priv->m_pauseIcon = _tmp19_;
	_tmp20_ = (GtkImage*) gtk_image_new_from_icon_name ("audio-volume-muted-symbolic", GTK_ICON_SIZE_DND);
	g_object_ref_sink (_tmp20_);
	_g_object_unref0 (self->priv->m_muteIcon);
	self->priv->m_muteIcon = _tmp20_;
	_tmp21_ = (GtkImage*) gtk_image_new_from_icon_name ("audio-volume-high-symbolic", GTK_ICON_SIZE_DND);
	g_object_ref_sink (_tmp21_);
	_g_object_unref0 (self->priv->m_noiseIcon);
	self->priv->m_noiseIcon = _tmp21_;
	_tmp22_ = (GtkImage*) gtk_image_new_from_icon_name ("window-close-symbolic", GTK_ICON_SIZE_SMALL_TOOLBAR);
	g_object_ref_sink (_tmp22_);
	_g_object_unref0 (self->priv->m_closeIcon);
	self->priv->m_closeIcon = _tmp22_;
	_tmp23_ = (GtkButton*) gtk_button_new ();
	g_object_ref_sink (_tmp23_);
	_g_object_unref0 (self->priv->m_playButton);
	self->priv->m_playButton = _tmp23_;
	_tmp24_ = self->priv->m_playButton;
	_tmp25_ = self->priv->m_playIcon;
	gtk_button_set_image (_tmp24_, (GtkWidget*) _tmp25_);
	_tmp26_ = self->priv->m_playButton;
	g_signal_connect_object (_tmp26_, "clicked", (GCallback) _feed_reader_media_player_togglePause_gtk_button_clicked, self, 0);
	_tmp27_ = self->priv->m_playButton;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp27_, FEED_READER_MEDIA_BUTTON_PLAY);
	_tmp28_ = self->priv->m_playButton;
	gtk_widget_set_valign ((GtkWidget*) _tmp28_, GTK_ALIGN_CENTER);
	_tmp29_ = self->priv->m_playButton;
	gtk_widget_set_halign ((GtkWidget*) _tmp29_, GTK_ALIGN_CENTER);
	_tmp30_ = self->priv->m_playButton;
	gtk_widget_set_size_request ((GtkWidget*) _tmp30_, 48, 48);
	_tmp31_ = (GtkSpinner*) gtk_spinner_new ();
	g_object_ref_sink (_tmp31_);
	_g_object_unref0 (self->priv->m_playSpinner);
	self->priv->m_playSpinner = _tmp31_;
	_tmp32_ = (GtkStack*) gtk_stack_new ();
	g_object_ref_sink (_tmp32_);
	_g_object_unref0 (self->priv->m_playStack);
	self->priv->m_playStack = _tmp32_;
	_tmp33_ = self->priv->m_playStack;
	_tmp34_ = self->priv->m_playButton;
	gtk_stack_add_named (_tmp33_, (GtkWidget*) _tmp34_, "button");
	_tmp35_ = self->priv->m_playStack;
	_tmp36_ = self->priv->m_playSpinner;
	gtk_stack_add_named (_tmp35_, (GtkWidget*) _tmp36_, "spinner");
	_tmp37_ = self->priv->m_playStack;
	gtk_stack_set_visible_child_name (_tmp37_, "button");
	_tmp38_ = (GtkButton*) gtk_button_new ();
	g_object_ref_sink (_tmp38_);
	_g_object_unref0 (self->priv->m_muteButton);
	self->priv->m_muteButton = _tmp38_;
	_tmp39_ = self->priv->m_muteButton;
	_tmp40_ = self->priv->m_noiseIcon;
	gtk_button_set_image (_tmp39_, (GtkWidget*) _tmp40_);
	_tmp41_ = self->priv->m_muteButton;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp41_, FEED_READER_MEDIA_BUTTON_MUTE);
	_tmp42_ = self->priv->m_muteButton;
	g_signal_connect_object (_tmp42_, "clicked", (GCallback) _feed_reader_media_player_toggleMute_gtk_button_clicked, self, 0);
	_tmp43_ = self->priv->m_muteButton;
	gtk_widget_set_valign ((GtkWidget*) _tmp43_, GTK_ALIGN_CENTER);
	_tmp44_ = self->priv->m_muteButton;
	gtk_widget_set_halign ((GtkWidget*) _tmp44_, GTK_ALIGN_CENTER);
	_tmp45_ = self->priv->m_muteButton;
	gtk_widget_set_size_request ((GtkWidget*) _tmp45_, 48, 48);
	_tmp46_ = (GtkButton*) gtk_button_new ();
	g_object_ref_sink (_tmp46_);
	_g_object_unref0 (self->priv->m_closeButton);
	self->priv->m_closeButton = _tmp46_;
	_tmp47_ = self->priv->m_closeButton;
	_tmp48_ = self->priv->m_closeIcon;
	gtk_button_set_image (_tmp47_, (GtkWidget*) _tmp48_);
	_tmp49_ = self->priv->m_closeButton;
	g_signal_connect_object (_tmp49_, "clicked", (GCallback) ___lambda98__gtk_button_clicked, self, 0);
	_tmp50_ = self->priv->m_closeButton;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp50_, FEED_READER_MEDIA_BUTTON_CLOSE);
	_tmp51_ = self->priv->m_closeButton;
	gtk_widget_set_valign ((GtkWidget*) _tmp51_, GTK_ALIGN_CENTER);
	_tmp52_ = self->priv->m_closeButton;
	gtk_widget_set_halign ((GtkWidget*) _tmp52_, GTK_ALIGN_CENTER);
	_tmp53_ = self->priv->m_closeButton;
	gtk_widget_set_size_request ((GtkWidget*) _tmp53_, 48, 48);
	_tmp54_ = (GtkScale*) gtk_scale_new_with_range (GTK_ORIENTATION_HORIZONTAL, 0.0, 100.0, 5.0);
	g_object_ref_sink (_tmp54_);
	_g_object_unref0 (self->priv->m_scale);
	self->priv->m_scale = _tmp54_;
	_tmp55_ = self->priv->m_scale;
	gtk_scale_set_draw_value (_tmp55_, FALSE);
	_tmp56_ = self->priv->m_scale;
	gtk_widget_set_size_request ((GtkWidget*) _tmp56_, 200, 48);
	_tmp57_ = self->priv->m_scale;
	g_signal_connect_object ((GtkRange*) _tmp57_, "change-value", (GCallback) _feed_reader_media_player_valueChanged_gtk_range_change_value, self, 0);
	_tmp58_ = (GtkButton*) gtk_button_new_with_label ("00:00");
	g_object_ref_sink (_tmp58_);
	_g_object_unref0 (self->priv->m_labelButton);
	self->priv->m_labelButton = _tmp58_;
	_tmp59_ = self->priv->m_labelButton;
	gtk_button_set_relief (_tmp59_, GTK_RELIEF_NONE);
	_tmp60_ = self->priv->m_labelButton;
	_tmp61_ = gtk_widget_get_style_context ((GtkWidget*) _tmp60_);
	gtk_style_context_add_class (_tmp61_, "h3");
	_tmp62_ = self->priv->m_labelButton;
	g_signal_connect_object (_tmp62_, "clicked", (GCallback) _feed_reader_media_player_switchDisplay_gtk_button_clicked, self, 0);
	_tmp63_ = self->priv->m_labelButton;
	gtk_widget_set_valign ((GtkWidget*) _tmp63_, GTK_ALIGN_CENTER);
	_tmp64_ = self->priv->m_labelButton;
	gtk_widget_set_halign ((GtkWidget*) _tmp64_, GTK_ALIGN_CENTER);
	_tmp65_ = self->priv->m_labelButton;
	gtk_widget_set_size_request ((GtkWidget*) _tmp65_, 48, 48);
	_tmp66_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 10);
	g_object_ref_sink (_tmp66_);
	hBox = _tmp66_;
	_tmp67_ = hBox;
	_tmp68_ = self->priv->m_margin;
	g_object_set ((GtkWidget*) _tmp67_, "margin", _tmp68_, NULL);
	_tmp69_ = hBox;
	_tmp70_ = self->priv->m_playStack;
	gtk_box_pack_start (_tmp69_, (GtkWidget*) _tmp70_, FALSE, FALSE, (guint) 0);
	_tmp71_ = hBox;
	_tmp72_ = self->priv->m_muteButton;
	gtk_box_pack_start (_tmp71_, (GtkWidget*) _tmp72_, FALSE, FALSE, (guint) 0);
	_tmp73_ = hBox;
	_tmp74_ = self->priv->m_scale;
	gtk_box_pack_start (_tmp73_, (GtkWidget*) _tmp74_, TRUE, TRUE, (guint) 0);
	_tmp75_ = hBox;
	_tmp76_ = self->priv->m_labelButton;
	gtk_box_pack_start (_tmp75_, (GtkWidget*) _tmp76_, FALSE, FALSE, (guint) 0);
	_tmp77_ = hBox;
	_tmp78_ = self->priv->m_closeButton;
	gtk_box_pack_start (_tmp77_, (GtkWidget*) _tmp78_, FALSE, FALSE, (guint) 0);
	_tmp79_ = (GtkLabel*) gtk_label_new ("0%");
	g_object_ref_sink (_tmp79_);
	_g_object_unref0 (self->priv->m_bufferLabel);
	self->priv->m_bufferLabel = _tmp79_;
	_tmp80_ = self->priv->m_bufferLabel;
	gtk_widget_set_valign ((GtkWidget*) _tmp80_, GTK_ALIGN_CENTER);
	_tmp81_ = self->priv->m_bufferLabel;
	gtk_widget_set_halign ((GtkWidget*) _tmp81_, GTK_ALIGN_CENTER);
	_tmp82_ = self->priv->m_bufferLabel;
	gtk_widget_set_size_request ((GtkWidget*) _tmp82_, 48, 48);
	_tmp83_ = self->priv->m_bufferLabel;
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp83_, TRUE);
	_tmp84_ = (GtkOverlay*) gtk_overlay_new ();
	g_object_ref_sink (_tmp84_);
	bufferOverlay = _tmp84_;
	_tmp85_ = bufferOverlay;
	_tmp86_ = self->priv->m_videoWidget;
	gtk_container_add ((GtkContainer*) _tmp85_, _tmp86_);
	_tmp87_ = bufferOverlay;
	_tmp88_ = self->priv->m_bufferLabel;
	gtk_overlay_add_overlay (_tmp87_, (GtkWidget*) _tmp88_);
	gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_VERTICAL);
	_tmp89_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp89_, "osd");
	g_object_set ((GtkWidget*) self, "margin", 40, NULL);
	_tmp90_ = self->priv->m_type;
	if (_tmp90_ == FEED_READER_MEDIA_TYPE_VIDEO) {
		GtkOverlay* _tmp91_;
		_tmp91_ = bufferOverlay;
		gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp91_, TRUE, TRUE, (guint) 0);
	}
	_tmp92_ = hBox;
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp92_, FALSE, FALSE, (guint) 0);
	gtk_widget_set_valign ((GtkWidget*) self, GTK_ALIGN_END);
	gtk_widget_show_all ((GtkWidget*) self);
	_g_object_unref0 (bufferOverlay);
	_g_object_unref0 (hBox);
	_g_object_unref0 (bus);
	_g_object_unref0 (gtksink);
}


static void feed_reader_media_player_togglePause (FeedReaderMediaPlayer* self) {
	GstState state = 0;
	GstState pending = 0;
	GstElement* _tmp0_;
	GstState _tmp1_ = 0;
	GstState _tmp2_ = 0;
	GstState _tmp3_;
	gboolean _tmp12_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->m_player;
	gst_element_get_state (_tmp0_, &_tmp1_, &_tmp2_, (GstClockTime) 1000);
	state = _tmp1_;
	pending = _tmp2_;
	_tmp3_ = state;
	switch (_tmp3_) {
		case GST_STATE_PLAYING:
		{
			GtkButton* _tmp4_;
			GtkImage* _tmp5_;
			GtkButton* _tmp6_;
			GstElement* _tmp7_;
			_tmp4_ = self->priv->m_playButton;
			_tmp5_ = self->priv->m_playIcon;
			gtk_button_set_image (_tmp4_, (GtkWidget*) _tmp5_);
			_tmp6_ = self->priv->m_playButton;
			gtk_widget_set_tooltip_text ((GtkWidget*) _tmp6_, FEED_READER_MEDIA_BUTTON_PLAY);
			_tmp7_ = self->priv->m_player;
			gst_element_set_state (_tmp7_, GST_STATE_PAUSED);
			break;
		}
		default:
		case GST_STATE_PAUSED:
		case GST_STATE_READY:
		{
			GtkButton* _tmp8_;
			GtkImage* _tmp9_;
			GtkButton* _tmp10_;
			GstElement* _tmp11_;
			_tmp8_ = self->priv->m_playButton;
			_tmp9_ = self->priv->m_pauseIcon;
			gtk_button_set_image (_tmp8_, (GtkWidget*) _tmp9_);
			_tmp10_ = self->priv->m_playButton;
			gtk_widget_set_tooltip_text ((GtkWidget*) _tmp10_, FEED_READER_MEDIA_BUTTON_PAUSE);
			_tmp11_ = self->priv->m_player;
			gst_element_set_state (_tmp11_, GST_STATE_PLAYING);
			break;
		}
	}
	_tmp12_ = self->priv->m_muted;
	if (_tmp12_) {
		GstElement* _tmp13_;
		_tmp13_ = self->priv->m_player;
		g_object_set ((GObject*) _tmp13_, "volume", 0.0, NULL);
	} else {
		GstElement* _tmp14_;
		_tmp14_ = self->priv->m_player;
		g_object_set ((GObject*) _tmp14_, "volume", 1.0, NULL);
	}
}


static void feed_reader_media_player_switchDisplay (FeedReaderMediaPlayer* self) {
	FeedReaderDisplayPosition _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->m_display;
	switch (_tmp0_) {
		case FEED_READER_DISPLAY_POSITION_ALL:
		{
			self->priv->m_display = FEED_READER_DISPLAY_POSITION_POS;
			break;
		}
		case FEED_READER_DISPLAY_POSITION_POS:
		{
			self->priv->m_display = FEED_READER_DISPLAY_POSITION_LEFT;
			break;
		}
		case FEED_READER_DISPLAY_POSITION_LEFT:
		{
			self->priv->m_display = FEED_READER_DISPLAY_POSITION_ALL;
			break;
		}
		default:
		break;
	}
	feed_reader_media_player_calcTime (self);
}


static gdouble* _double_dup (gdouble* self) {
	gdouble* dup;
	dup = g_new0 (gdouble, 1);
	memcpy (dup, self, sizeof (gdouble));
	return dup;
}


static gpointer __double_dup0 (gpointer self) {
	return self ? _double_dup (self) : NULL;
}


static void feed_reader_media_player_calcTime (FeedReaderMediaPlayer* self) {
	gint64 pos = 0LL;
	gint64 dur = 0LL;
	GstElement* _tmp0_;
	gint64 _tmp1_ = 0LL;
	GstElement* _tmp2_;
	gint64 _tmp3_ = 0LL;
	gdouble position = 0.0;
	gint64 _tmp4_;
	gdouble duration = 0.0;
	gint64 _tmp5_;
	gdouble* sd = NULL;
	gdouble _tmp6_;
	gdouble* _tmp7_;
	gdouble* md = NULL;
	gdouble* hd = NULL;
	gdouble* _tmp8_;
	gdouble* sp = NULL;
	gdouble _tmp24_;
	gdouble* _tmp25_;
	gdouble* mp = NULL;
	gdouble* hp = NULL;
	gdouble* _tmp26_;
	gdouble* sr = NULL;
	gdouble _tmp42_;
	gdouble _tmp43_;
	gdouble _tmp44_;
	gdouble* _tmp45_;
	gdouble* mr = NULL;
	gdouble* hr = NULL;
	gdouble* _tmp46_;
	gchar* pLabel = NULL;
	gchar* _tmp62_;
	const gchar* _tmp63_ = NULL;
	gdouble* _tmp64_;
	const gchar* _tmp71_ = NULL;
	gdouble* _tmp72_;
	const gchar* _tmp79_ = NULL;
	gdouble* _tmp80_;
	const gchar* _tmp87_;
	gdouble* _tmp88_;
	gchar* _tmp89_;
	gchar* _tmp90_;
	gchar* _tmp91_;
	gchar* dLabel = NULL;
	gchar* _tmp92_;
	const gchar* _tmp93_ = NULL;
	gdouble* _tmp94_;
	const gchar* _tmp101_ = NULL;
	gdouble* _tmp102_;
	const gchar* _tmp109_ = NULL;
	gdouble* _tmp110_;
	const gchar* _tmp117_;
	gdouble* _tmp118_;
	gchar* _tmp119_;
	gchar* _tmp120_;
	gchar* _tmp121_;
	gchar* rLabel = NULL;
	gchar* _tmp122_;
	const gchar* _tmp123_ = NULL;
	gdouble* _tmp124_;
	const gchar* _tmp131_ = NULL;
	gdouble* _tmp132_;
	const gchar* _tmp139_ = NULL;
	gdouble* _tmp140_;
	const gchar* _tmp147_;
	gdouble* _tmp148_;
	gchar* _tmp149_;
	gchar* _tmp150_;
	gchar* _tmp151_;
	gint64 _tmp152_;
	FeedReaderDisplayPosition _tmp155_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->m_player;
	gst_element_query_position (_tmp0_, GST_FORMAT_TIME, &_tmp1_);
	pos = _tmp1_;
	_tmp2_ = self->priv->m_player;
	gst_element_query_duration (_tmp2_, GST_FORMAT_TIME, &_tmp3_);
	dur = _tmp3_;
	_tmp4_ = pos;
	position = (gdouble) ((gint) (((gdouble) _tmp4_) / 1000000000));
	_tmp5_ = dur;
	duration = (gdouble) ((gint) (((gdouble) _tmp5_) / 1000000000));
	_tmp6_ = duration;
	_tmp7_ = __double_dup0 (&_tmp6_);
	sd = _tmp7_;
	md = NULL;
	hd = NULL;
	_tmp8_ = sd;
	if (((gint) (*_tmp8_)) >= 60) {
		gdouble* _tmp9_;
		gdouble _tmp10_;
		gdouble* _tmp11_;
		gdouble* _tmp12_;
		gdouble* _tmp13_;
		gdouble _tmp14_;
		gdouble* _tmp15_;
		gdouble* _tmp16_;
		_tmp9_ = sd;
		_tmp10_ = (gdouble) ((gint) ((*_tmp9_) / 60));
		_tmp11_ = __double_dup0 (&_tmp10_);
		_g_free0 (md);
		md = _tmp11_;
		_tmp12_ = sd;
		_tmp13_ = md;
		_tmp14_ = (*_tmp12_) - ((*_tmp13_) * 60);
		_tmp15_ = __double_dup0 (&_tmp14_);
		_g_free0 (sd);
		sd = _tmp15_;
		_tmp16_ = md;
		if (((gint) (*_tmp16_)) >= 60) {
			gdouble* _tmp17_;
			gdouble _tmp18_;
			gdouble* _tmp19_;
			gdouble* _tmp20_;
			gdouble* _tmp21_;
			gdouble _tmp22_;
			gdouble* _tmp23_;
			_tmp17_ = md;
			_tmp18_ = (gdouble) ((gint) ((*_tmp17_) / 60));
			_tmp19_ = __double_dup0 (&_tmp18_);
			_g_free0 (hd);
			hd = _tmp19_;
			_tmp20_ = md;
			_tmp21_ = hd;
			_tmp22_ = (*_tmp20_) - ((*_tmp21_) * 60);
			_tmp23_ = __double_dup0 (&_tmp22_);
			_g_free0 (md);
			md = _tmp23_;
		}
	}
	_tmp24_ = position;
	_tmp25_ = __double_dup0 (&_tmp24_);
	sp = _tmp25_;
	mp = NULL;
	hp = NULL;
	_tmp26_ = sp;
	if (((gint) (*_tmp26_)) >= 60) {
		gdouble* _tmp27_;
		gdouble _tmp28_;
		gdouble* _tmp29_;
		gdouble* _tmp30_;
		gdouble* _tmp31_;
		gdouble _tmp32_;
		gdouble* _tmp33_;
		gdouble* _tmp34_;
		_tmp27_ = sp;
		_tmp28_ = (gdouble) ((gint) ((*_tmp27_) / 60));
		_tmp29_ = __double_dup0 (&_tmp28_);
		_g_free0 (mp);
		mp = _tmp29_;
		_tmp30_ = sp;
		_tmp31_ = mp;
		_tmp32_ = (*_tmp30_) - ((*_tmp31_) * 60);
		_tmp33_ = __double_dup0 (&_tmp32_);
		_g_free0 (sp);
		sp = _tmp33_;
		_tmp34_ = mp;
		if (((gint) (*_tmp34_)) >= 60) {
			gdouble* _tmp35_;
			gdouble _tmp36_;
			gdouble* _tmp37_;
			gdouble* _tmp38_;
			gdouble* _tmp39_;
			gdouble _tmp40_;
			gdouble* _tmp41_;
			_tmp35_ = mp;
			_tmp36_ = (gdouble) ((gint) ((*_tmp35_) / 60));
			_tmp37_ = __double_dup0 (&_tmp36_);
			_g_free0 (hp);
			hp = _tmp37_;
			_tmp38_ = mp;
			_tmp39_ = hp;
			_tmp40_ = (*_tmp38_) - ((*_tmp39_) * 60);
			_tmp41_ = __double_dup0 (&_tmp40_);
			_g_free0 (mp);
			mp = _tmp41_;
		}
	}
	_tmp42_ = duration;
	_tmp43_ = position;
	_tmp44_ = _tmp42_ - _tmp43_;
	_tmp45_ = __double_dup0 (&_tmp44_);
	sr = _tmp45_;
	mr = NULL;
	hr = NULL;
	_tmp46_ = sr;
	if (((gint) (*_tmp46_)) >= 60) {
		gdouble* _tmp47_;
		gdouble _tmp48_;
		gdouble* _tmp49_;
		gdouble* _tmp50_;
		gdouble* _tmp51_;
		gdouble _tmp52_;
		gdouble* _tmp53_;
		gdouble* _tmp54_;
		_tmp47_ = sr;
		_tmp48_ = (gdouble) ((gint) ((*_tmp47_) / 60));
		_tmp49_ = __double_dup0 (&_tmp48_);
		_g_free0 (mr);
		mr = _tmp49_;
		_tmp50_ = sr;
		_tmp51_ = mr;
		_tmp52_ = (*_tmp50_) - ((*_tmp51_) * 60);
		_tmp53_ = __double_dup0 (&_tmp52_);
		_g_free0 (sr);
		sr = _tmp53_;
		_tmp54_ = mr;
		if (((gint) (*_tmp54_)) >= 60) {
			gdouble* _tmp55_;
			gdouble _tmp56_;
			gdouble* _tmp57_;
			gdouble* _tmp58_;
			gdouble* _tmp59_;
			gdouble _tmp60_;
			gdouble* _tmp61_;
			_tmp55_ = mr;
			_tmp56_ = (gdouble) ((gint) ((*_tmp55_) / 60));
			_tmp57_ = __double_dup0 (&_tmp56_);
			_g_free0 (hr);
			hr = _tmp57_;
			_tmp58_ = mr;
			_tmp59_ = hr;
			_tmp60_ = (*_tmp58_) - ((*_tmp59_) * 60);
			_tmp61_ = __double_dup0 (&_tmp60_);
			_g_free0 (mr);
			mr = _tmp61_;
		}
	}
	_tmp62_ = g_strdup ("");
	pLabel = _tmp62_;
	_tmp64_ = hp;
	if (_tmp64_ != NULL) {
		const gchar* _tmp65_;
		gdouble* _tmp66_;
		gchar* _tmp67_;
		gchar* _tmp68_;
		gchar* _tmp69_;
		const gchar* _tmp70_;
		_tmp65_ = pLabel;
		_tmp66_ = hp;
		_tmp67_ = g_strdup_printf ("%02.0f:", *_tmp66_);
		_tmp68_ = _tmp67_;
		_tmp69_ = g_strconcat (_tmp65_, _tmp68_, NULL);
		_g_free0 (pLabel);
		pLabel = _tmp69_;
		_tmp70_ = pLabel;
		_tmp63_ = _tmp70_;
		_g_free0 (_tmp68_);
	} else {
		_tmp63_ = NULL;
	}
	_tmp72_ = mp;
	if (_tmp72_ != NULL) {
		const gchar* _tmp73_;
		gdouble* _tmp74_;
		gchar* _tmp75_;
		gchar* _tmp76_;
		gchar* _tmp77_;
		const gchar* _tmp78_;
		_tmp73_ = pLabel;
		_tmp74_ = mp;
		_tmp75_ = g_strdup_printf ("%02.0f", *_tmp74_);
		_tmp76_ = _tmp75_;
		_tmp77_ = g_strconcat (_tmp73_, _tmp76_, NULL);
		_g_free0 (pLabel);
		pLabel = _tmp77_;
		_tmp78_ = pLabel;
		_tmp71_ = _tmp78_;
		_g_free0 (_tmp76_);
	} else {
		_tmp71_ = NULL;
	}
	_tmp80_ = mp;
	if (_tmp80_ != NULL) {
		const gchar* _tmp81_;
		gchar* _tmp82_;
		const gchar* _tmp83_;
		_tmp81_ = pLabel;
		_tmp82_ = g_strconcat (_tmp81_, ":", NULL);
		_g_free0 (pLabel);
		pLabel = _tmp82_;
		_tmp83_ = pLabel;
		_tmp79_ = _tmp83_;
	} else {
		const gchar* _tmp84_;
		gchar* _tmp85_;
		const gchar* _tmp86_;
		_tmp84_ = pLabel;
		_tmp85_ = g_strconcat (_tmp84_, "0:", NULL);
		_g_free0 (pLabel);
		pLabel = _tmp85_;
		_tmp86_ = pLabel;
		_tmp79_ = _tmp86_;
	}
	_tmp87_ = pLabel;
	_tmp88_ = sp;
	_tmp89_ = g_strdup_printf ("%02.0f", *_tmp88_);
	_tmp90_ = _tmp89_;
	_tmp91_ = g_strconcat (_tmp87_, _tmp90_, NULL);
	_g_free0 (pLabel);
	pLabel = _tmp91_;
	_g_free0 (_tmp90_);
	_tmp92_ = g_strdup ("");
	dLabel = _tmp92_;
	_tmp94_ = hd;
	if (_tmp94_ != NULL) {
		const gchar* _tmp95_;
		gdouble* _tmp96_;
		gchar* _tmp97_;
		gchar* _tmp98_;
		gchar* _tmp99_;
		const gchar* _tmp100_;
		_tmp95_ = dLabel;
		_tmp96_ = hd;
		_tmp97_ = g_strdup_printf ("%02.0f:", *_tmp96_);
		_tmp98_ = _tmp97_;
		_tmp99_ = g_strconcat (_tmp95_, _tmp98_, NULL);
		_g_free0 (dLabel);
		dLabel = _tmp99_;
		_tmp100_ = dLabel;
		_tmp93_ = _tmp100_;
		_g_free0 (_tmp98_);
	} else {
		_tmp93_ = NULL;
	}
	_tmp102_ = md;
	if (_tmp102_ != NULL) {
		const gchar* _tmp103_;
		gdouble* _tmp104_;
		gchar* _tmp105_;
		gchar* _tmp106_;
		gchar* _tmp107_;
		const gchar* _tmp108_;
		_tmp103_ = dLabel;
		_tmp104_ = md;
		_tmp105_ = g_strdup_printf ("%02.0f", *_tmp104_);
		_tmp106_ = _tmp105_;
		_tmp107_ = g_strconcat (_tmp103_, _tmp106_, NULL);
		_g_free0 (dLabel);
		dLabel = _tmp107_;
		_tmp108_ = dLabel;
		_tmp101_ = _tmp108_;
		_g_free0 (_tmp106_);
	} else {
		_tmp101_ = NULL;
	}
	_tmp110_ = md;
	if (_tmp110_ != NULL) {
		const gchar* _tmp111_;
		gchar* _tmp112_;
		const gchar* _tmp113_;
		_tmp111_ = dLabel;
		_tmp112_ = g_strconcat (_tmp111_, ":", NULL);
		_g_free0 (dLabel);
		dLabel = _tmp112_;
		_tmp113_ = dLabel;
		_tmp109_ = _tmp113_;
	} else {
		const gchar* _tmp114_;
		gchar* _tmp115_;
		const gchar* _tmp116_;
		_tmp114_ = dLabel;
		_tmp115_ = g_strconcat (_tmp114_, "0:", NULL);
		_g_free0 (dLabel);
		dLabel = _tmp115_;
		_tmp116_ = dLabel;
		_tmp109_ = _tmp116_;
	}
	_tmp117_ = dLabel;
	_tmp118_ = sd;
	_tmp119_ = g_strdup_printf ("%02.0f", *_tmp118_);
	_tmp120_ = _tmp119_;
	_tmp121_ = g_strconcat (_tmp117_, _tmp120_, NULL);
	_g_free0 (dLabel);
	dLabel = _tmp121_;
	_g_free0 (_tmp120_);
	_tmp122_ = g_strdup ("-");
	rLabel = _tmp122_;
	_tmp124_ = hr;
	if (_tmp124_ != NULL) {
		const gchar* _tmp125_;
		gdouble* _tmp126_;
		gchar* _tmp127_;
		gchar* _tmp128_;
		gchar* _tmp129_;
		const gchar* _tmp130_;
		_tmp125_ = rLabel;
		_tmp126_ = hr;
		_tmp127_ = g_strdup_printf ("%02.0f:", *_tmp126_);
		_tmp128_ = _tmp127_;
		_tmp129_ = g_strconcat (_tmp125_, _tmp128_, NULL);
		_g_free0 (rLabel);
		rLabel = _tmp129_;
		_tmp130_ = rLabel;
		_tmp123_ = _tmp130_;
		_g_free0 (_tmp128_);
	} else {
		_tmp123_ = NULL;
	}
	_tmp132_ = mr;
	if (_tmp132_ != NULL) {
		const gchar* _tmp133_;
		gdouble* _tmp134_;
		gchar* _tmp135_;
		gchar* _tmp136_;
		gchar* _tmp137_;
		const gchar* _tmp138_;
		_tmp133_ = rLabel;
		_tmp134_ = mr;
		_tmp135_ = g_strdup_printf ("%02.0f", *_tmp134_);
		_tmp136_ = _tmp135_;
		_tmp137_ = g_strconcat (_tmp133_, _tmp136_, NULL);
		_g_free0 (rLabel);
		rLabel = _tmp137_;
		_tmp138_ = rLabel;
		_tmp131_ = _tmp138_;
		_g_free0 (_tmp136_);
	} else {
		_tmp131_ = NULL;
	}
	_tmp140_ = mr;
	if (_tmp140_ != NULL) {
		const gchar* _tmp141_;
		gchar* _tmp142_;
		const gchar* _tmp143_;
		_tmp141_ = rLabel;
		_tmp142_ = g_strconcat (_tmp141_, ":", NULL);
		_g_free0 (rLabel);
		rLabel = _tmp142_;
		_tmp143_ = rLabel;
		_tmp139_ = _tmp143_;
	} else {
		const gchar* _tmp144_;
		gchar* _tmp145_;
		const gchar* _tmp146_;
		_tmp144_ = rLabel;
		_tmp145_ = g_strconcat (_tmp144_, "0:", NULL);
		_g_free0 (rLabel);
		rLabel = _tmp145_;
		_tmp146_ = rLabel;
		_tmp139_ = _tmp146_;
	}
	_tmp147_ = rLabel;
	_tmp148_ = sr;
	_tmp149_ = g_strdup_printf ("%02.0f", *_tmp148_);
	_tmp150_ = _tmp149_;
	_tmp151_ = g_strconcat (_tmp147_, _tmp150_, NULL);
	_g_free0 (rLabel);
	rLabel = _tmp151_;
	_g_free0 (_tmp150_);
	_tmp152_ = dur;
	if (_tmp152_ == ((gint64) -1)) {
		GtkButton* _tmp153_;
		const gchar* _tmp154_;
		_tmp153_ = self->priv->m_labelButton;
		_tmp154_ = pLabel;
		gtk_button_set_label (_tmp153_, _tmp154_);
		_g_free0 (rLabel);
		_g_free0 (dLabel);
		_g_free0 (pLabel);
		_g_free0 (hr);
		_g_free0 (mr);
		_g_free0 (sr);
		_g_free0 (hp);
		_g_free0 (mp);
		_g_free0 (sp);
		_g_free0 (hd);
		_g_free0 (md);
		_g_free0 (sd);
		return;
	}
	_tmp155_ = self->priv->m_display;
	switch (_tmp155_) {
		case FEED_READER_DISPLAY_POSITION_ALL:
		{
			GtkButton* _tmp156_;
			const gchar* _tmp157_;
			gchar* _tmp158_;
			gchar* _tmp159_;
			const gchar* _tmp160_;
			gchar* _tmp161_;
			gchar* _tmp162_;
			_tmp156_ = self->priv->m_labelButton;
			_tmp157_ = pLabel;
			_tmp158_ = g_strconcat (_tmp157_, " / ", NULL);
			_tmp159_ = _tmp158_;
			_tmp160_ = dLabel;
			_tmp161_ = g_strconcat (_tmp159_, _tmp160_, NULL);
			_tmp162_ = _tmp161_;
			gtk_button_set_label (_tmp156_, _tmp162_);
			_g_free0 (_tmp162_);
			_g_free0 (_tmp159_);
			break;
		}
		case FEED_READER_DISPLAY_POSITION_POS:
		{
			GtkButton* _tmp163_;
			const gchar* _tmp164_;
			_tmp163_ = self->priv->m_labelButton;
			_tmp164_ = pLabel;
			gtk_button_set_label (_tmp163_, _tmp164_);
			break;
		}
		case FEED_READER_DISPLAY_POSITION_LEFT:
		{
			GtkButton* _tmp165_;
			const gchar* _tmp166_;
			_tmp165_ = self->priv->m_labelButton;
			_tmp166_ = rLabel;
			gtk_button_set_label (_tmp165_, _tmp166_);
			break;
		}
		default:
		break;
	}
	_g_free0 (rLabel);
	_g_free0 (dLabel);
	_g_free0 (pLabel);
	_g_free0 (hr);
	_g_free0 (mr);
	_g_free0 (sr);
	_g_free0 (hp);
	_g_free0 (mp);
	_g_free0 (sp);
	_g_free0 (hd);
	_g_free0 (md);
	_g_free0 (sd);
}


static Block31Data* block31_data_ref (Block31Data* _data31_) {
	g_atomic_int_inc (&_data31_->_ref_count_);
	return _data31_;
}


static void block31_data_unref (void * _userdata_) {
	Block31Data* _data31_;
	_data31_ = (Block31Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data31_->_ref_count_)) {
		FeedReaderMediaPlayer* self;
		self = _data31_->self;
		_g_object_unref0 (self);
		g_slice_free (Block31Data, _data31_);
	}
}


static gboolean ___lambda99_ (Block31Data* _data31_) {
	FeedReaderMediaPlayer* self;
	gboolean result = FALSE;
	GtkScale* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	self = _data31_->self;
	_tmp0_ = self->priv->m_scale;
	_tmp1_ = gtk_range_get_value ((GtkRange*) _tmp0_);
	_tmp2_ = _data31_->startValue;
	if (_tmp1_ != _tmp2_) {
		GtkScale* _tmp3_;
		gdouble _tmp4_;
		_tmp3_ = self->priv->m_scale;
		_tmp4_ = gtk_range_get_value ((GtkRange*) _tmp3_);
		_data31_->startValue = _tmp4_;
		result = TRUE;
		return result;
	} else {
		gdouble _tmp5_;
		self->priv->m_seek_source_id = (guint) 0;
		_tmp5_ = _data31_->startValue;
		feed_reader_media_player_seek (self, _tmp5_);
		result = FALSE;
		return result;
	}
}


static gboolean ____lambda99__gsource_func (gpointer self) {
	gboolean result;
	result = ___lambda99_ (self);
	return result;
}


static gboolean feed_reader_media_player_valueChanged (FeedReaderMediaPlayer* self, GtkScrollType scroll, gdouble new_value) {
	gboolean result = FALSE;
	GtkScale* _tmp0_;
	gdouble _tmp1_;
	guint _tmp2_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->m_scale;
	_tmp1_ = new_value;
	gtk_range_set_value ((GtkRange*) _tmp0_, _tmp1_);
	_tmp2_ = self->priv->m_seek_source_id;
	if (_tmp2_ == ((guint) 0)) {
		Block31Data* _data31_;
		gdouble _tmp3_;
		guint _tmp4_;
		_data31_ = g_slice_new0 (Block31Data);
		_data31_->_ref_count_ = 1;
		_data31_->self = g_object_ref (self);
		_tmp3_ = new_value;
		_data31_->startValue = _tmp3_;
		_tmp4_ = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 500, ____lambda99__gsource_func, block31_data_ref (_data31_), block31_data_unref);
		self->priv->m_seek_source_id = _tmp4_;
		block31_data_unref (_data31_);
		_data31_ = NULL;
	}
	result = TRUE;
	return result;
}


static void feed_reader_media_player_seek (FeedReaderMediaPlayer* self, gdouble new_value) {
	gint64 dur = 0LL;
	gdouble percent = 0.0;
	gdouble _tmp0_;
	GstElement* _tmp1_;
	gint64 _tmp2_ = 0LL;
	gint64 pos = 0LL;
	GstElement* _tmp3_;
	GtkButton* _tmp4_;
	GtkImage* _tmp5_;
	GstElement* _tmp6_;
	g_return_if_fail (self != NULL);
	_tmp0_ = new_value;
	percent = _tmp0_ / 100.0;
	_tmp1_ = self->priv->m_player;
	gst_element_query_duration (_tmp1_, GST_FORMAT_TIME, &_tmp2_);
	dur = _tmp2_;
	pos = (gint64) (percent * ((gdouble) dur));
	_tmp3_ = self->priv->m_player;
	gst_element_seek_simple (_tmp3_, GST_FORMAT_TIME, GST_SEEK_FLAG_FLUSH | GST_SEEK_FLAG_KEY_UNIT, pos);
	_tmp4_ = self->priv->m_playButton;
	_tmp5_ = self->priv->m_pauseIcon;
	gtk_button_set_image (_tmp4_, (GtkWidget*) _tmp5_);
	_tmp6_ = self->priv->m_player;
	gst_element_set_state (_tmp6_, GST_STATE_PLAYING);
}


static void feed_reader_media_player_toggleMute (FeedReaderMediaPlayer* self) {
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->m_muted;
	if (_tmp0_) {
		GtkButton* _tmp1_;
		GtkImage* _tmp2_;
		GtkButton* _tmp3_;
		GstElement* _tmp4_;
		_tmp1_ = self->priv->m_muteButton;
		_tmp2_ = self->priv->m_noiseIcon;
		gtk_button_set_image (_tmp1_, (GtkWidget*) _tmp2_);
		_tmp3_ = self->priv->m_muteButton;
		gtk_widget_set_tooltip_text ((GtkWidget*) _tmp3_, FEED_READER_MEDIA_BUTTON_MUTE);
		_tmp4_ = self->priv->m_player;
		g_object_set ((GObject*) _tmp4_, "volume", 1.0, NULL);
		self->priv->m_muted = FALSE;
	} else {
		GtkButton* _tmp5_;
		GtkImage* _tmp6_;
		GtkButton* _tmp7_;
		GstElement* _tmp8_;
		_tmp5_ = self->priv->m_muteButton;
		_tmp6_ = self->priv->m_muteIcon;
		gtk_button_set_image (_tmp5_, (GtkWidget*) _tmp6_);
		_tmp7_ = self->priv->m_muteButton;
		gtk_widget_set_tooltip_text ((GtkWidget*) _tmp7_, FEED_READER_MEDIA_BUTTON_UNMUTE);
		_tmp8_ = self->priv->m_player;
		g_object_set ((GObject*) _tmp8_, "volume", 0.0, NULL);
		self->priv->m_muted = TRUE;
	}
}


static gboolean feed_reader_media_player_busCallback (FeedReaderMediaPlayer* self, GstBus* bus, GstMessage* message) {
	gboolean result = FALSE;
	GstMessage* _tmp0_;
	GstMessageType _tmp1_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (bus != NULL, FALSE);
	g_return_val_if_fail (message != NULL, FALSE);
	_tmp0_ = message;
	_tmp1_ = _tmp0_->type;
	switch (_tmp1_) {
		case GST_MESSAGE_ERROR:
		{
			GError* err = NULL;
			gchar* debug = NULL;
			GstMessage* _tmp2_;
			GError* _tmp3_ = NULL;
			gchar* _tmp4_ = NULL;
			GError* _tmp5_;
			const gchar* _tmp6_;
			gchar* _tmp7_;
			gchar* _tmp8_;
			GstElement* _tmp9_;
			_tmp2_ = message;
			gst_message_parse_error (_tmp2_, &_tmp3_, &_tmp4_);
			_g_error_free0 (err);
			err = _tmp3_;
			_g_free0 (debug);
			debug = _tmp4_;
			_tmp5_ = err;
			_tmp6_ = _tmp5_->message;
			_tmp7_ = g_strconcat ("MediaPlayer: ", _tmp6_, NULL);
			_tmp8_ = _tmp7_;
			feed_reader_logger_error (_tmp8_);
			_g_free0 (_tmp8_);
			_tmp9_ = self->priv->m_player;
			gst_element_set_state (_tmp9_, GST_STATE_NULL);
			_g_free0 (debug);
			_g_error_free0 (err);
			break;
		}
		case GST_MESSAGE_EOS:
		{
			GstElement* _tmp10_;
			GtkButton* _tmp11_;
			GtkImage* _tmp12_;
			_tmp10_ = self->priv->m_player;
			gst_element_set_state (_tmp10_, GST_STATE_READY);
			_tmp11_ = self->priv->m_playButton;
			_tmp12_ = self->priv->m_playIcon;
			gtk_button_set_image (_tmp11_, (GtkWidget*) _tmp12_);
			break;
		}
		case GST_MESSAGE_BUFFERING:
		{
			gint percent = 0;
			GstMessage* _tmp13_;
			gint _tmp14_ = 0;
			gint _tmp15_;
			percent = 0;
			_tmp13_ = message;
			gst_message_parse_buffering (_tmp13_, &_tmp14_);
			percent = _tmp14_;
			_tmp15_ = percent;
			if (_tmp15_ < 100) {
				GstElement* _tmp16_;
				FeedReaderMediaType _tmp17_;
				_tmp16_ = self->priv->m_player;
				gst_element_set_state (_tmp16_, GST_STATE_PAUSED);
				_tmp17_ = self->priv->m_type;
				if (_tmp17_ == FEED_READER_MEDIA_TYPE_VIDEO) {
					GtkLabel* _tmp18_;
					gint _tmp19_;
					gchar* _tmp20_;
					gchar* _tmp21_;
					gchar* _tmp22_;
					gchar* _tmp23_;
					GtkLabel* _tmp24_;
					_tmp18_ = self->priv->m_bufferLabel;
					_tmp19_ = percent;
					_tmp20_ = g_strdup_printf ("%i", _tmp19_);
					_tmp21_ = _tmp20_;
					_tmp22_ = g_strconcat (_tmp21_, "%", NULL);
					_tmp23_ = _tmp22_;
					gtk_label_set_text (_tmp18_, _tmp23_);
					_g_free0 (_tmp23_);
					_g_free0 (_tmp21_);
					_tmp24_ = self->priv->m_bufferLabel;
					gtk_widget_show ((GtkWidget*) _tmp24_);
				} else {
					GtkStack* _tmp25_;
					GtkSpinner* _tmp26_;
					_tmp25_ = self->priv->m_playStack;
					gtk_stack_set_visible_child_name (_tmp25_, "spinner");
					_tmp26_ = self->priv->m_playSpinner;
					gtk_spinner_start (_tmp26_);
				}
			} else {
				GstElement* _tmp27_;
				FeedReaderMediaType _tmp28_;
				_tmp27_ = self->priv->m_player;
				gst_element_set_state (_tmp27_, GST_STATE_PLAYING);
				_tmp28_ = self->priv->m_type;
				if (_tmp28_ == FEED_READER_MEDIA_TYPE_VIDEO) {
					GtkLabel* _tmp29_;
					_tmp29_ = self->priv->m_bufferLabel;
					gtk_widget_hide ((GtkWidget*) _tmp29_);
				} else {
					GtkStack* _tmp30_;
					_tmp30_ = self->priv->m_playStack;
					gtk_stack_set_visible_child_name (_tmp30_, "button");
				}
			}
			break;
		}
		case GST_MESSAGE_STATE_CHANGED:
		{
			GstState oldstate = 0;
			GstState newstate = 0;
			GstState pending = 0;
			GstMessage* _tmp31_;
			GstState _tmp32_ = 0;
			GstState _tmp33_ = 0;
			GstState _tmp34_ = 0;
			_tmp31_ = message;
			gst_message_parse_state_changed (_tmp31_, &_tmp32_, &_tmp33_, &_tmp34_);
			oldstate = _tmp32_;
			newstate = _tmp33_;
			pending = _tmp34_;
			break;
		}
		default:
		break;
	}
	result = TRUE;
	return result;
}


static void feed_reader_media_player_onAllocation (FeedReaderMediaPlayer* self, GtkAllocation* allocation) {
	gdouble _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (allocation != NULL);
	_tmp0_ = self->priv->m_aspectRatio;
	if (_tmp0_ != ((gdouble) 0)) {
		gdouble width = 0.0;
		GtkAllocation _tmp1_;
		gint _tmp2_;
		gint height = 0;
		gdouble _tmp3_;
		gdouble _tmp4_;
		GtkWidget* _tmp5_;
		gint _tmp6_;
		_tmp1_ = *allocation;
		_tmp2_ = _tmp1_.width;
		width = (gdouble) _tmp2_;
		_tmp3_ = width;
		_tmp4_ = self->priv->m_aspectRatio;
		height = (gint) (_tmp3_ / _tmp4_);
		_tmp5_ = self->priv->m_videoWidget;
		_tmp6_ = height;
		gtk_widget_set_size_request (_tmp5_, -1, _tmp6_);
	}
}


void feed_reader_media_player_kill (FeedReaderMediaPlayer* self) {
	GstElement* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->m_player;
	gst_element_set_state (_tmp0_, GST_STATE_NULL);
	gtk_widget_destroy ((GtkWidget*) self);
}


static void feed_reader_media_player_class_init (FeedReaderMediaPlayerClass * klass) {
	feed_reader_media_player_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (FeedReaderMediaPlayerPrivate));
	G_OBJECT_CLASS (klass)->finalize = feed_reader_media_player_finalize;
	feed_reader_media_player_signals[FEED_READER_MEDIA_PLAYER_LOADED_SIGNAL] = g_signal_new ("loaded", FEED_READER_TYPE_MEDIA_PLAYER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void feed_reader_media_player_instance_init (FeedReaderMediaPlayer * self) {
	self->priv = FEED_READER_MEDIA_PLAYER_GET_PRIVATE (self);
	self->priv->m_margin = 20;
	self->priv->m_muted = FALSE;
	self->priv->m_aspectRatio = 0.0;
	self->priv->m_seek_source_id = (guint) 0;
	self->priv->m_display = FEED_READER_DISPLAY_POSITION_ALL;
}


static void feed_reader_media_player_finalize (GObject * obj) {
	FeedReaderMediaPlayer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FEED_READER_TYPE_MEDIA_PLAYER, FeedReaderMediaPlayer);
	_g_object_unref0 (self->priv->m_player);
	_g_object_unref0 (self->priv->m_videoWidget);
	_g_object_unref0 (self->priv->m_playStack);
	_g_object_unref0 (self->priv->m_playButton);
	_g_object_unref0 (self->priv->m_playSpinner);
	_g_object_unref0 (self->priv->m_muteButton);
	_g_object_unref0 (self->priv->m_closeButton);
	_g_object_unref0 (self->priv->m_scale);
	_g_object_unref0 (self->priv->m_labelButton);
	_g_object_unref0 (self->priv->m_bufferLabel);
	_g_object_unref0 (self->priv->m_playIcon);
	_g_object_unref0 (self->priv->m_pauseIcon);
	_g_object_unref0 (self->priv->m_muteIcon);
	_g_object_unref0 (self->priv->m_noiseIcon);
	_g_object_unref0 (self->priv->m_closeIcon);
	_g_free0 (self->priv->m_URL);
	G_OBJECT_CLASS (feed_reader_media_player_parent_class)->finalize (obj);
}


GType feed_reader_media_player_get_type (void) {
	static volatile gsize feed_reader_media_player_type_id__volatile = 0;
	if (g_once_init_enter (&feed_reader_media_player_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (FeedReaderMediaPlayerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) feed_reader_media_player_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FeedReaderMediaPlayer), 0, (GInstanceInitFunc) feed_reader_media_player_instance_init, NULL };
		GType feed_reader_media_player_type_id;
		feed_reader_media_player_type_id = g_type_register_static (gtk_box_get_type (), "FeedReaderMediaPlayer", &g_define_type_info, 0);
		g_once_init_leave (&feed_reader_media_player_type_id__volatile, feed_reader_media_player_type_id);
	}
	return feed_reader_media_player_type_id__volatile;
}



