/* feedbinAPI.c generated by valac 0.38.8, the Vala compiler
 * generated from feedbinAPI.vala, do not modify */

/*This file is part of FeedReader.*/
/**/
/*FeedReader is free software: you can redistribute it and/or modify*/
/*it under the terms of the GNU General Public License as published by*/
/*the Free Software Foundation, either version 3 of the License, or*/
/*(at your option) any later version.*/
/**/
/*FeedReader is distributed in the hope that it will be useful,*/
/*but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*GNU General Public License for more details.*/
/**/
/*You should have received a copy of the GNU General Public License*/
/*along with FeedReader.  If not, see <http://www.gnu.org/licenses/>.*/
/* TODO: Make a general-purpose HttpClient module with these errors*/

#include <glib.h>
#include <glib-object.h>
#include <libsoup/soup.h>
#include <stdlib.h>
#include <string.h>
#include <json-glib/json-glib.h>
#include <gee.h>


#define TYPE_FEEDBIN_API (feedbin_api_get_type ())
#define FEEDBIN_API(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FEEDBIN_API, FeedbinAPI))
#define FEEDBIN_API_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FEEDBIN_API, FeedbinAPIClass))
#define IS_FEEDBIN_API(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FEEDBIN_API))
#define IS_FEEDBIN_API_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FEEDBIN_API))
#define FEEDBIN_API_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FEEDBIN_API, FeedbinAPIClass))

typedef struct _FeedbinAPI FeedbinAPI;
typedef struct _FeedbinAPIClass FeedbinAPIClass;
typedef struct _FeedbinAPIPrivate FeedbinAPIPrivate;
enum  {
	FEEDBIN_API_0_PROPERTY,
	FEEDBIN_API_USERNAME_PROPERTY,
	FEEDBIN_API_PASSWORD_PROPERTY,
	FEEDBIN_API_NUM_PROPERTIES
};
static GParamSpec* feedbin_api_properties[FEEDBIN_API_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define __vala_SoupBuffer_free0(var) ((var == NULL) ? NULL : (var = (_vala_SoupBuffer_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define __vala_JsonNode_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonNode_free (var), NULL)))

#define FEEDBIN_API_TYPE_SUBSCRIPTION (feedbin_api_subscription_get_type ())
typedef struct _FeedbinAPISubscription FeedbinAPISubscription;
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))
#define _json_array_unref0(var) ((var == NULL) ? NULL : (var = (json_array_unref (var), NULL)))

#define FEEDBIN_API_TYPE_TAGGING (feedbin_api_tagging_get_type ())
typedef struct _FeedbinAPITagging FeedbinAPITagging;

#define FEEDBIN_API_TYPE_ENTRY (feedbin_api_entry_get_type ())
typedef struct _FeedbinAPIEntry FeedbinAPIEntry;
#define _g_bytes_unref0(var) ((var == NULL) ? NULL : (var = (g_bytes_unref (var), NULL)))

typedef enum  {
	FEEDBIN_ERROR_INVALID_FORMAT,
	FEEDBIN_ERROR_MULTIPLE_CHOICES,
	FEEDBIN_ERROR_NO_CONNECTION,
	FEEDBIN_ERROR_NOT_AUTHORIZED,
	FEEDBIN_ERROR_NOT_FOUND,
	FEEDBIN_ERROR_UNKNOWN_ERROR
} FeedbinError;
#define FEEDBIN_ERROR feedbin_error_quark ()
struct _FeedbinAPI {
	GObject parent_instance;
	FeedbinAPIPrivate * priv;
};

struct _FeedbinAPIClass {
	GObjectClass parent_class;
};

struct _FeedbinAPIPrivate {
	SoupSession* m_session;
	gchar* m_base_uri;
	gchar* _username;
	gchar* _password;
};

struct _FeedbinAPISubscription {
	gint64 id;
	GDateTime* created_at;
	gint64 feed_id;
	gchar* title;
	gchar* feed_url;
	gchar* site_url;
};

struct _FeedbinAPITagging {
	gint64 id;
	gint64 feed_id;
	gchar* name;
};

struct _FeedbinAPIEntry {
	gint64 id;
	gint64 feed_id;
	gchar* title;
	gchar* url;
	gchar* author;
	gchar* content;
	gchar* summary;
	GDateTime* published;
	GDateTime* created_at;
};


static gpointer feedbin_api_parent_class = NULL;

GQuark feedbin_error_quark (void);
GType feedbin_api_get_type (void) G_GNUC_CONST;
#define FEEDBIN_API_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_FEEDBIN_API, FeedbinAPIPrivate))
static void feedbin_api_authenticate (FeedbinAPI* self, SoupMessage* msg, SoupAuth* auth, gboolean retrying);
static void _feedbin_api_authenticate_soup_session_authenticate (SoupSession* _sender, SoupMessage* msg, SoupAuth* auth, gboolean retrying, gpointer self);
#define FEEDBIN_API_BASE_URI_FORMAT "%s/v2/"
FeedbinAPI* feedbin_api_new (const gchar* username, const gchar* password, const gchar* user_agent, const gchar* host);
FeedbinAPI* feedbin_api_construct (GType object_type, const gchar* username, const gchar* password, const gchar* user_agent, const gchar* host);
void feedbin_api_set_username (FeedbinAPI* self, const gchar* value);
void feedbin_api_set_password (FeedbinAPI* self, const gchar* value);
const gchar* feedbin_api_get_username (FeedbinAPI* self);
const gchar* feedbin_api_get_password (FeedbinAPI* self);
static SoupMessage* feedbin_api_request (FeedbinAPI* self, const gchar* method, const gchar* last_part, const gchar* input, GError** error);
static guint8* _vala_array_dup1 (guint8* self, int length);
static GDateTime* feedbin_api_string_to_datetime (const gchar* s, GError** error);
static GDateTime* feedbin_api_get_datetime_member (JsonObject* obj, const gchar* name, GError** error);
static SoupMessage* feedbin_api_post_request (FeedbinAPI* self, const gchar* path, const gchar* input, GError** error);
static SoupMessage* feedbin_api_delete_request (FeedbinAPI* self, const gchar* path, const gchar* input, GError** error);
static SoupMessage* feedbin_api_get_request (FeedbinAPI* self, const gchar* path, GError** error);
static JsonNode* feedbin_api_parse_json (SoupMessage* response, GError** error);
static void _vala_SoupBuffer_free (SoupBuffer* self);
static JsonNode* _vala_JsonNode_copy (JsonNode* self);
static JsonNode* feedbin_api_get_json (FeedbinAPI* self, const gchar* path, GError** error);
static void _vala_JsonNode_free (JsonNode* self);
static SoupMessage* feedbin_api_post_json_object (FeedbinAPI* self, const gchar* path, JsonObject* obj, GError** error);
gboolean feedbin_api_login (FeedbinAPI* self, GError** error);
GType feedbin_api_subscription_get_type (void) G_GNUC_CONST;
FeedbinAPISubscription* feedbin_api_subscription_dup (const FeedbinAPISubscription* self);
void feedbin_api_subscription_free (FeedbinAPISubscription* self);
void feedbin_api_subscription_copy (const FeedbinAPISubscription* self, FeedbinAPISubscription* dest);
void feedbin_api_subscription_destroy (FeedbinAPISubscription* self);
void feedbin_api_get_subscription (FeedbinAPI* self, gint64 subscription_id, FeedbinAPISubscription* result, GError** error);
void feedbin_api_subscription_init_from_json (FeedbinAPISubscription *self, JsonObject* object, GError** error);
GeeList* feedbin_api_get_subscriptions (FeedbinAPI* self, GError** error);
void feedbin_api_delete_subscription (FeedbinAPI* self, gint64 subscription_id, GError** error);
FeedbinAPISubscription* feedbin_api_add_subscription (FeedbinAPI* self, const gchar* url, GError** error);
void feedbin_api_rename_subscription (FeedbinAPI* self, gint64 subscription_id, const gchar* title, GError** error);
void feedbin_api_add_tagging (FeedbinAPI* self, gint64 feed_id, const gchar* tag_name, GError** error);
void feedbin_api_delete_tagging (FeedbinAPI* self, gint64 tagging_id, GError** error);
GType feedbin_api_tagging_get_type (void) G_GNUC_CONST;
FeedbinAPITagging* feedbin_api_tagging_dup (const FeedbinAPITagging* self);
void feedbin_api_tagging_free (FeedbinAPITagging* self);
void feedbin_api_tagging_copy (const FeedbinAPITagging* self, FeedbinAPITagging* dest);
void feedbin_api_tagging_destroy (FeedbinAPITagging* self);
GeeList* feedbin_api_get_taggings (FeedbinAPI* self, GError** error);
void feedbin_api_tagging_init_from_json (FeedbinAPITagging *self, JsonObject* object);
GType feedbin_api_entry_get_type (void) G_GNUC_CONST;
FeedbinAPIEntry* feedbin_api_entry_dup (const FeedbinAPIEntry* self);
void feedbin_api_entry_free (FeedbinAPIEntry* self);
void feedbin_api_entry_copy (const FeedbinAPIEntry* self, FeedbinAPIEntry* dest);
void feedbin_api_entry_destroy (FeedbinAPIEntry* self);
GeeList* feedbin_api_get_entries (FeedbinAPI* self, gint page, gboolean only_starred, GDateTime* since, gint64* feed_id, GError** error);
void feedbin_api_entry_init_from_json (FeedbinAPIEntry *self, JsonObject* object, GError** error);
static GeeSet* feedbin_api_get_x_entries (FeedbinAPI* self, const gchar* path, GError** error);
static guint __lambda4_ (FeedbinAPI* self, gint64* n);
static guint ___lambda4__gee_hash_data_func (gconstpointer v, gpointer self);
static gboolean __lambda5_ (FeedbinAPI* self, gint64* a, gint64* b);
static gboolean ___lambda5__gee_equal_data_func (gconstpointer a, gconstpointer b, gpointer self);
static gint64* _int64_dup (gint64* self);
GeeSet* feedbin_api_get_unread_entries (FeedbinAPI* self, GError** error);
GeeSet* feedbin_api_get_starred_entries (FeedbinAPI* self, GError** error);
static void feedbin_api_set_entries_status (FeedbinAPI* self, const gchar* type, GeeCollection* entry_ids, gboolean create, GError** error);
void feedbin_api_set_entries_read (FeedbinAPI* self, GeeCollection* entry_ids, gboolean read, GError** error);
void feedbin_api_set_entries_starred (FeedbinAPI* self, GeeCollection* entry_ids, gboolean starred, GError** error);
GeeMap* feedbin_api_get_favicons (FeedbinAPI* self, GError** error);
static void feedbin_api_finalize (GObject * obj);
static void _vala_feedbin_api_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_feedbin_api_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


GQuark feedbin_error_quark (void) {
	return g_quark_from_static_string ("feedbin_error-quark");
}


static void _feedbin_api_authenticate_soup_session_authenticate (SoupSession* _sender, SoupMessage* msg, SoupAuth* auth, gboolean retrying, gpointer self) {
	feedbin_api_authenticate ((FeedbinAPI*) self, msg, auth, retrying);
}


FeedbinAPI* feedbin_api_construct (GType object_type, const gchar* username, const gchar* password, const gchar* user_agent, const gchar* host) {
	FeedbinAPI * self = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	SoupSession* _tmp4_;
	const gchar* _tmp5_;
	SoupSession* _tmp8_;
	g_return_val_if_fail (username != NULL, NULL);
	g_return_val_if_fail (password != NULL, NULL);
	self = (FeedbinAPI*) g_object_new (object_type, NULL);
	_tmp0_ = username;
	feedbin_api_set_username (self, _tmp0_);
	_tmp1_ = password;
	feedbin_api_set_password (self, _tmp1_);
	_tmp2_ = host;
	_tmp3_ = g_strdup_printf (FEEDBIN_API_BASE_URI_FORMAT, _tmp2_);
	_g_free0 (self->priv->m_base_uri);
	self->priv->m_base_uri = _tmp3_;
	_tmp4_ = soup_session_new ();
	_g_object_unref0 (self->priv->m_session);
	self->priv->m_session = _tmp4_;
	_tmp5_ = user_agent;
	if (_tmp5_ != NULL) {
		SoupSession* _tmp6_;
		const gchar* _tmp7_;
		_tmp6_ = self->priv->m_session;
		_tmp7_ = user_agent;
		g_object_set (_tmp6_, "user-agent", _tmp7_, NULL);
	}
	_tmp8_ = self->priv->m_session;
	g_signal_connect_object (_tmp8_, "authenticate", (GCallback) _feedbin_api_authenticate_soup_session_authenticate, self, 0);
	return self;
}


FeedbinAPI* feedbin_api_new (const gchar* username, const gchar* password, const gchar* user_agent, const gchar* host) {
	return feedbin_api_construct (TYPE_FEEDBIN_API, username, password, user_agent, host);
}


static void feedbin_api_authenticate (FeedbinAPI* self, SoupMessage* msg, SoupAuth* auth, gboolean retrying) {
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (msg != NULL);
	g_return_if_fail (auth != NULL);
	_tmp0_ = retrying;
	if (!_tmp0_) {
		SoupAuth* _tmp1_;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		_tmp1_ = auth;
		_tmp2_ = self->priv->_username;
		_tmp3_ = self->priv->_password;
		soup_auth_authenticate (_tmp1_, _tmp2_, _tmp3_);
	}
}


static guint8* string_get_data (const gchar* self, int* result_length1) {
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	guint8* _tmp3_;
	gint _tmp3__length1;
	guint8* _tmp4_;
	gint _tmp4__length1;
	g_return_val_if_fail (self != NULL, NULL);
	res = (guint8*) self;
	res_length1 = -1;
	_res_size_ = res_length1;
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	res_length1 = (gint) _tmp1_;
	_tmp2_ = res_length1;
	_tmp3_ = res;
	_tmp3__length1 = res_length1;
	_tmp4_ = _tmp3_;
	_tmp4__length1 = _tmp3__length1;
	if (result_length1) {
		*result_length1 = _tmp4__length1;
	}
	result = _tmp4_;
	return result;
}


static guint8* _vala_array_dup1 (guint8* self, int length) {
	return g_memdup (self, length * sizeof (guint8));
}


static const gchar* string_to_string (const gchar* self) {
	const gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}


static SoupMessage* feedbin_api_request (FeedbinAPI* self, const gchar* method, const gchar* last_part, const gchar* input, GError** error) {
	SoupMessage* result = NULL;
	gchar* path = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	SoupMessage* message = NULL;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	SoupMessage* _tmp5_;
	gboolean _tmp6_ = FALSE;
	const gchar* _tmp7_;
	const gchar* _tmp11_;
	SoupSession* _tmp18_;
	SoupMessage* _tmp19_;
	guint status = 0U;
	SoupMessage* _tmp20_;
	guint _tmp21_;
	guint _tmp22_;
	gboolean _tmp23_ = FALSE;
	guint _tmp24_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (method != NULL, NULL);
	g_return_val_if_fail (last_part != NULL, NULL);
	_tmp0_ = self->priv->m_base_uri;
	_tmp1_ = last_part;
	_tmp2_ = g_strconcat (_tmp0_, _tmp1_, NULL);
	path = _tmp2_;
	_tmp3_ = method;
	_tmp4_ = path;
	_tmp5_ = soup_message_new (_tmp3_, _tmp4_);
	message = _tmp5_;
	_tmp7_ = method;
	if (g_strcmp0 (_tmp7_, "POST") == 0) {
		_tmp6_ = TRUE;
	} else {
		const gchar* _tmp8_;
		_tmp8_ = method;
		_tmp6_ = g_strcmp0 (_tmp8_, "PUT") == 0;
	}
	if (_tmp6_) {
		SoupMessage* _tmp9_;
		SoupMessageHeaders* _tmp10_;
		_tmp9_ = message;
		_tmp10_ = _tmp9_->request_headers;
		soup_message_headers_append (_tmp10_, "Content-Type", "application/json; charset=utf-8");
	}
	_tmp11_ = input;
	if (_tmp11_ != NULL) {
		SoupMessage* _tmp12_;
		SoupMessageBody* _tmp13_;
		const gchar* _tmp14_;
		guint8* _tmp15_;
		gint _tmp15__length1;
		guint8* _tmp16_;
		gint _tmp16__length1;
		guint8* _tmp17_;
		gint _tmp17__length1;
		_tmp12_ = message;
		_tmp13_ = _tmp12_->request_body;
		_tmp14_ = input;
		_tmp15_ = string_get_data (_tmp14_, &_tmp15__length1);
		_tmp16_ = _tmp15_;
		_tmp16__length1 = _tmp15__length1;
		_tmp17_ = (_tmp16_ != NULL) ? _vala_array_dup1 (_tmp16_, _tmp16__length1) : ((gpointer) _tmp16_);
		_tmp17__length1 = _tmp16__length1;
		soup_message_body_append_take (_tmp13_, _tmp17_, (gsize) _tmp17__length1);
	}
	_tmp18_ = self->priv->m_session;
	_tmp19_ = message;
	soup_session_send_message (_tmp18_, _tmp19_);
	_tmp20_ = message;
	g_object_get (_tmp20_, "status-code", &_tmp21_, NULL);
	_tmp22_ = _tmp21_;
	status = _tmp22_;
	_tmp24_ = status;
	if (_tmp24_ < ((guint) 200)) {
		_tmp23_ = TRUE;
	} else {
		guint _tmp25_;
		_tmp25_ = status;
		_tmp23_ = _tmp25_ >= ((guint) 400);
	}
	if (_tmp23_) {
		guint _tmp26_;
		gchar* phrase = NULL;
		guint _tmp49_;
		const gchar* _tmp50_;
		gchar* _tmp51_;
		guint _tmp52_;
		gchar* _tmp53_;
		gchar* _tmp54_;
		const gchar* _tmp55_;
		const gchar* _tmp56_;
		const gchar* _tmp57_;
		const gchar* _tmp58_;
		const gchar* _tmp59_;
		const gchar* _tmp60_;
		gchar* _tmp61_;
		gchar* _tmp62_;
		GError* _tmp63_;
		GError* _tmp64_;
		_tmp26_ = status;
		switch (_tmp26_) {
			case SOUP_STATUS_CANT_RESOLVE:
			case SOUP_STATUS_CANT_RESOLVE_PROXY:
			case SOUP_STATUS_CANT_CONNECT:
			case SOUP_STATUS_CANT_CONNECT_PROXY:
			{
				const gchar* _tmp27_;
				const gchar* _tmp28_;
				gchar* _tmp29_;
				gchar* _tmp30_;
				GError* _tmp31_;
				GError* _tmp32_;
				_tmp27_ = self->priv->m_base_uri;
				_tmp28_ = string_to_string (_tmp27_);
				_tmp29_ = g_strconcat ("Connection to ", _tmp28_, " failed", NULL);
				_tmp30_ = _tmp29_;
				_tmp31_ = g_error_new_literal (FEEDBIN_ERROR, FEEDBIN_ERROR_NO_CONNECTION, _tmp30_);
				_tmp32_ = _tmp31_;
				_g_free0 (_tmp30_);
				_inner_error_ = _tmp32_;
				if (_inner_error_->domain == FEEDBIN_ERROR) {
					g_propagate_error (error, _inner_error_);
					_g_object_unref0 (message);
					_g_free0 (path);
					return NULL;
				} else {
					_g_object_unref0 (message);
					_g_free0 (path);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return NULL;
				}
			}
			case SOUP_STATUS_UNAUTHORIZED:
			{
				const gchar* _tmp33_;
				const gchar* _tmp34_;
				const gchar* _tmp35_;
				const gchar* _tmp36_;
				gchar* _tmp37_;
				gchar* _tmp38_;
				GError* _tmp39_;
				GError* _tmp40_;
				_tmp33_ = method;
				_tmp34_ = string_to_string (_tmp33_);
				_tmp35_ = path;
				_tmp36_ = string_to_string (_tmp35_);
				_tmp37_ = g_strconcat ("Not authorized to ", _tmp34_, " ", _tmp36_, NULL);
				_tmp38_ = _tmp37_;
				_tmp39_ = g_error_new_literal (FEEDBIN_ERROR, FEEDBIN_ERROR_NOT_AUTHORIZED, _tmp38_);
				_tmp40_ = _tmp39_;
				_g_free0 (_tmp38_);
				_inner_error_ = _tmp40_;
				if (_inner_error_->domain == FEEDBIN_ERROR) {
					g_propagate_error (error, _inner_error_);
					_g_object_unref0 (message);
					_g_free0 (path);
					return NULL;
				} else {
					_g_object_unref0 (message);
					_g_free0 (path);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return NULL;
				}
			}
			case SOUP_STATUS_NOT_FOUND:
			{
				const gchar* _tmp41_;
				const gchar* _tmp42_;
				const gchar* _tmp43_;
				const gchar* _tmp44_;
				gchar* _tmp45_;
				gchar* _tmp46_;
				GError* _tmp47_;
				GError* _tmp48_;
				_tmp41_ = method;
				_tmp42_ = string_to_string (_tmp41_);
				_tmp43_ = path;
				_tmp44_ = string_to_string (_tmp43_);
				_tmp45_ = g_strconcat (_tmp42_, " ", _tmp44_, " not found", NULL);
				_tmp46_ = _tmp45_;
				_tmp47_ = g_error_new_literal (FEEDBIN_ERROR, FEEDBIN_ERROR_NOT_FOUND, _tmp46_);
				_tmp48_ = _tmp47_;
				_g_free0 (_tmp46_);
				_inner_error_ = _tmp48_;
				if (_inner_error_->domain == FEEDBIN_ERROR) {
					g_propagate_error (error, _inner_error_);
					_g_object_unref0 (message);
					_g_free0 (path);
					return NULL;
				} else {
					_g_object_unref0 (message);
					_g_free0 (path);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return NULL;
				}
			}
			default:
			break;
		}
		_tmp49_ = status;
		_tmp50_ = soup_status_get_phrase (_tmp49_);
		_tmp51_ = g_strdup (_tmp50_);
		phrase = _tmp51_;
		_tmp52_ = status;
		_tmp53_ = g_strdup_printf ("%u", _tmp52_);
		_tmp54_ = _tmp53_;
		_tmp55_ = phrase;
		_tmp56_ = string_to_string (_tmp55_);
		_tmp57_ = method;
		_tmp58_ = string_to_string (_tmp57_);
		_tmp59_ = path;
		_tmp60_ = string_to_string (_tmp59_);
		_tmp61_ = g_strconcat ("Unexpected status ", _tmp54_, " (", _tmp56_, ") for ", _tmp58_, " ", _tmp60_, NULL);
		_tmp62_ = _tmp61_;
		_tmp63_ = g_error_new_literal (FEEDBIN_ERROR, FEEDBIN_ERROR_UNKNOWN_ERROR, _tmp62_);
		_tmp64_ = _tmp63_;
		_g_free0 (_tmp62_);
		_g_free0 (_tmp54_);
		_inner_error_ = _tmp64_;
		if (_inner_error_->domain == FEEDBIN_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_free0 (phrase);
			_g_object_unref0 (message);
			_g_free0 (path);
			return NULL;
		} else {
			_g_free0 (phrase);
			_g_object_unref0 (message);
			_g_free0 (path);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_g_free0 (phrase);
	}
	result = message;
	_g_free0 (path);
	return result;
}


static GDateTime* feedbin_api_string_to_datetime (const gchar* s, GError** error) {
	GDateTime* result = NULL;
	GTimeVal time = {0};
	const gchar* _tmp0_;
	gboolean _tmp1_;
	GTimeVal _tmp8_;
	GDateTime* _tmp9_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (s != NULL, NULL);
	g_get_current_time (&time);
	_tmp0_ = s;
	_tmp1_ = g_time_val_from_iso8601 (_tmp0_, &time);
	if (!_tmp1_) {
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		GError* _tmp6_;
		GError* _tmp7_;
		_tmp2_ = s;
		_tmp3_ = string_to_string (_tmp2_);
		_tmp4_ = g_strconcat ("Expected date but got ", _tmp3_, NULL);
		_tmp5_ = _tmp4_;
		_tmp6_ = g_error_new_literal (FEEDBIN_ERROR, FEEDBIN_ERROR_INVALID_FORMAT, _tmp5_);
		_tmp7_ = _tmp6_;
		_g_free0 (_tmp5_);
		_inner_error_ = _tmp7_;
		if (_inner_error_->domain == FEEDBIN_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp8_ = time;
	_tmp9_ = g_date_time_new_from_timeval_utc (&_tmp8_);
	result = _tmp9_;
	return result;
}


static GDateTime* feedbin_api_get_datetime_member (JsonObject* obj, const gchar* name, GError** error) {
	GDateTime* result = NULL;
	gchar* s = NULL;
	JsonObject* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	GDateTime* _tmp4_ = NULL;
	GDateTime* _tmp5_;
	GDateTime* _tmp6_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (obj != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	_tmp0_ = obj;
	_tmp1_ = name;
	_tmp2_ = json_object_get_string_member (_tmp0_, _tmp1_);
	_tmp3_ = g_strdup (_tmp2_);
	s = _tmp3_;
	_tmp5_ = feedbin_api_string_to_datetime (s, &_inner_error_);
	_tmp4_ = _tmp5_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == FEEDBIN_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_free0 (s);
			return NULL;
		} else {
			_g_free0 (s);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp6_ = _tmp4_;
	_tmp4_ = NULL;
	result = _tmp6_;
	_g_date_time_unref0 (_tmp4_);
	_g_free0 (s);
	return result;
}


static SoupMessage* feedbin_api_post_request (FeedbinAPI* self, const gchar* path, const gchar* input, GError** error) {
	SoupMessage* result = NULL;
	SoupMessage* _tmp0_ = NULL;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	SoupMessage* _tmp3_;
	SoupMessage* _tmp4_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (path != NULL, NULL);
	g_return_val_if_fail (input != NULL, NULL);
	_tmp1_ = path;
	_tmp2_ = input;
	_tmp3_ = feedbin_api_request (self, "POST", _tmp1_, _tmp2_, &_inner_error_);
	_tmp0_ = _tmp3_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == FEEDBIN_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp4_ = _tmp0_;
	_tmp0_ = NULL;
	result = _tmp4_;
	_g_object_unref0 (_tmp0_);
	return result;
}


static SoupMessage* feedbin_api_delete_request (FeedbinAPI* self, const gchar* path, const gchar* input, GError** error) {
	SoupMessage* result = NULL;
	SoupMessage* _tmp0_ = NULL;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	SoupMessage* _tmp3_;
	SoupMessage* _tmp4_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (path != NULL, NULL);
	_tmp1_ = path;
	_tmp2_ = input;
	_tmp3_ = feedbin_api_request (self, "DELETE", _tmp1_, _tmp2_, &_inner_error_);
	_tmp0_ = _tmp3_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == FEEDBIN_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp4_ = _tmp0_;
	_tmp0_ = NULL;
	result = _tmp4_;
	_g_object_unref0 (_tmp0_);
	return result;
}


static SoupMessage* feedbin_api_get_request (FeedbinAPI* self, const gchar* path, GError** error) {
	SoupMessage* result = NULL;
	SoupMessage* _tmp0_ = NULL;
	const gchar* _tmp1_;
	SoupMessage* _tmp2_;
	SoupMessage* _tmp3_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (path != NULL, NULL);
	_tmp1_ = path;
	_tmp2_ = feedbin_api_request (self, "GET", _tmp1_, NULL, &_inner_error_);
	_tmp0_ = _tmp2_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == FEEDBIN_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp3_ = _tmp0_;
	_tmp0_ = NULL;
	result = _tmp3_;
	_g_object_unref0 (_tmp0_);
	return result;
}


static void _vala_SoupBuffer_free (SoupBuffer* self) {
	g_boxed_free (soup_buffer_get_type (), self);
}


static JsonNode* _vala_JsonNode_copy (JsonNode* self) {
	return g_boxed_copy (json_node_get_type (), self);
}


static gpointer __vala_JsonNode_copy0 (gpointer self) {
	return self ? _vala_JsonNode_copy (self) : NULL;
}


static JsonNode* feedbin_api_parse_json (SoupMessage* response, GError** error) {
	JsonNode* result = NULL;
	gchar* method = NULL;
	SoupMessage* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* uri = NULL;
	SoupMessage* _tmp3_;
	SoupURI* _tmp4_;
	SoupURI* _tmp5_;
	gchar* _tmp6_;
	gchar* content = NULL;
	SoupMessage* _tmp7_;
	SoupMessageBody* _tmp8_;
	SoupBuffer* _tmp9_;
	SoupBuffer* _tmp10_;
	guint8* _tmp11_;
	gint _tmp11__length1;
	gchar* _tmp12_;
	gchar* _tmp13_;
	const gchar* _tmp14_;
	JsonParser* parser = NULL;
	JsonParser* _tmp23_;
	JsonParser* _tmp40_;
	JsonNode* _tmp41_;
	JsonNode* _tmp42_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (response != NULL, NULL);
	_tmp0_ = response;
	g_object_get (_tmp0_, "method", &_tmp1_, NULL);
	_tmp2_ = _tmp1_;
	method = _tmp2_;
	_tmp3_ = response;
	_tmp4_ = soup_message_get_uri (_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = soup_uri_to_string (_tmp5_, FALSE);
	uri = _tmp6_;
	_tmp7_ = response;
	_tmp8_ = _tmp7_->response_body;
	_tmp9_ = soup_message_body_flatten (_tmp8_);
	_tmp10_ = _tmp9_;
	_tmp11_ = _tmp10_->data;
	_tmp11__length1 = (gint) _tmp10_->length;
	_tmp12_ = g_strdup ((const gchar*) _tmp11_);
	_tmp13_ = _tmp12_;
	__vala_SoupBuffer_free0 (_tmp10_);
	content = _tmp13_;
	_tmp14_ = content;
	if (_tmp14_ == NULL) {
		const gchar* _tmp15_;
		const gchar* _tmp16_;
		const gchar* _tmp17_;
		const gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		GError* _tmp21_;
		GError* _tmp22_;
		_tmp15_ = method;
		_tmp16_ = string_to_string (_tmp15_);
		_tmp17_ = uri;
		_tmp18_ = string_to_string (_tmp17_);
		_tmp19_ = g_strconcat (_tmp16_, " ", _tmp18_, " returned no content but expected JSON", NULL);
		_tmp20_ = _tmp19_;
		_tmp21_ = g_error_new_literal (FEEDBIN_ERROR, FEEDBIN_ERROR_INVALID_FORMAT, _tmp20_);
		_tmp22_ = _tmp21_;
		_g_free0 (_tmp20_);
		_inner_error_ = _tmp22_;
		if (_inner_error_->domain == FEEDBIN_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_free0 (content);
			_g_free0 (uri);
			_g_free0 (method);
			return NULL;
		} else {
			_g_free0 (content);
			_g_free0 (uri);
			_g_free0 (method);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp23_ = json_parser_new ();
	parser = _tmp23_;
	{
		JsonParser* _tmp24_;
		const gchar* _tmp25_;
		_tmp24_ = parser;
		_tmp25_ = content;
		json_parser_load_from_data (_tmp24_, _tmp25_, (gssize) -1, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp26_;
		const gchar* _tmp27_;
		const gchar* _tmp28_;
		const gchar* _tmp29_;
		gchar* _tmp30_;
		gchar* _tmp31_;
		GError* _tmp32_;
		const gchar* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
		gchar* _tmp37_;
		GError* _tmp38_;
		GError* _tmp39_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp26_ = method;
		_tmp27_ = string_to_string (_tmp26_);
		_tmp28_ = uri;
		_tmp29_ = string_to_string (_tmp28_);
		_tmp30_ = g_strconcat (_tmp27_, " ", _tmp29_, " returned invalid JSON: ", NULL);
		_tmp31_ = _tmp30_;
		_tmp32_ = e;
		_tmp33_ = _tmp32_->message;
		_tmp34_ = g_strconcat (_tmp31_, _tmp33_, NULL);
		_tmp35_ = _tmp34_;
		_tmp36_ = g_strconcat (_tmp35_, "\nContent is: $content", NULL);
		_tmp37_ = _tmp36_;
		_tmp38_ = g_error_new_literal (FEEDBIN_ERROR, FEEDBIN_ERROR_INVALID_FORMAT, _tmp37_);
		_tmp39_ = _tmp38_;
		_g_free0 (_tmp37_);
		_g_free0 (_tmp35_);
		_g_free0 (_tmp31_);
		_inner_error_ = _tmp39_;
		_g_error_free0 (e);
		goto __finally0;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == FEEDBIN_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (parser);
			_g_free0 (content);
			_g_free0 (uri);
			_g_free0 (method);
			return NULL;
		} else {
			_g_object_unref0 (parser);
			_g_free0 (content);
			_g_free0 (uri);
			_g_free0 (method);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp40_ = parser;
	_tmp41_ = json_parser_get_root (_tmp40_);
	_tmp42_ = __vala_JsonNode_copy0 (_tmp41_);
	result = _tmp42_;
	_g_object_unref0 (parser);
	_g_free0 (content);
	_g_free0 (uri);
	_g_free0 (method);
	return result;
}


static void _vala_JsonNode_free (JsonNode* self) {
	g_boxed_free (json_node_get_type (), self);
}


static JsonNode* feedbin_api_get_json (FeedbinAPI* self, const gchar* path, GError** error) {
	JsonNode* result = NULL;
	SoupMessage* response = NULL;
	const gchar* _tmp0_;
	SoupMessage* _tmp1_;
	JsonNode* _tmp2_ = NULL;
	SoupMessage* _tmp3_;
	JsonNode* _tmp4_;
	JsonNode* _tmp5_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (path != NULL, NULL);
	_tmp0_ = path;
	_tmp1_ = feedbin_api_get_request (self, _tmp0_, &_inner_error_);
	response = _tmp1_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == FEEDBIN_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp3_ = response;
	_tmp4_ = feedbin_api_parse_json (_tmp3_, &_inner_error_);
	_tmp2_ = _tmp4_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == FEEDBIN_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (response);
			return NULL;
		} else {
			_g_object_unref0 (response);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp5_ = _tmp2_;
	_tmp2_ = NULL;
	result = _tmp5_;
	__vala_JsonNode_free0 (_tmp2_);
	_g_object_unref0 (response);
	return result;
}


static SoupMessage* feedbin_api_post_json_object (FeedbinAPI* self, const gchar* path, JsonObject* obj, GError** error) {
	SoupMessage* result = NULL;
	JsonNode* root = NULL;
	JsonNode* _tmp0_;
	JsonObject* _tmp1_;
	JsonGenerator* gen = NULL;
	JsonGenerator* _tmp2_;
	gchar* data = NULL;
	gchar* _tmp3_;
	SoupMessage* _tmp4_ = NULL;
	const gchar* _tmp5_;
	SoupMessage* _tmp6_;
	SoupMessage* _tmp7_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (path != NULL, NULL);
	g_return_val_if_fail (obj != NULL, NULL);
	_tmp0_ = json_node_new (JSON_NODE_OBJECT);
	root = _tmp0_;
	_tmp1_ = obj;
	json_node_set_object (root, _tmp1_);
	_tmp2_ = json_generator_new ();
	gen = _tmp2_;
	json_generator_set_root (gen, root);
	_tmp3_ = json_generator_to_data (gen, NULL);
	data = _tmp3_;
	_tmp5_ = path;
	_tmp6_ = feedbin_api_post_request (self, _tmp5_, data, &_inner_error_);
	_tmp4_ = _tmp6_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == FEEDBIN_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_free0 (data);
			_g_object_unref0 (gen);
			__vala_JsonNode_free0 (root);
			return NULL;
		} else {
			_g_free0 (data);
			_g_object_unref0 (gen);
			__vala_JsonNode_free0 (root);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp7_ = _tmp4_;
	_tmp4_ = NULL;
	result = _tmp7_;
	_g_object_unref0 (_tmp4_);
	_g_free0 (data);
	_g_object_unref0 (gen);
	__vala_JsonNode_free0 (root);
	return result;
}


gboolean feedbin_api_login (FeedbinAPI* self, GError** error) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	{
		SoupMessage* res = NULL;
		SoupMessage* _tmp0_;
		guint _tmp1_;
		guint _tmp2_;
		_tmp0_ = feedbin_api_get_request (self, "authentication.json", &_inner_error_);
		res = _tmp0_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (g_error_matches (_inner_error_, FEEDBIN_ERROR, FEEDBIN_ERROR_NOT_AUTHORIZED)) {
				goto __catch1_feedbin_error_not_authorized;
			}
			goto __finally1;
		}
		g_object_get (res, "status-code", &_tmp1_, NULL);
		_tmp2_ = _tmp1_;
		result = _tmp2_ == ((guint) SOUP_STATUS_OK);
		_g_object_unref0 (res);
		return result;
	}
	goto __finally1;
	__catch1_feedbin_error_not_authorized:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		result = FALSE;
		_g_error_free0 (e);
		return result;
	}
	__finally1:
	if (_inner_error_->domain == FEEDBIN_ERROR) {
		gboolean _tmp3_ = FALSE;
		g_propagate_error (error, _inner_error_);
		return _tmp3_;
	} else {
		gboolean _tmp4_ = FALSE;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return _tmp4_;
	}
}


void feedbin_api_get_subscription (FeedbinAPI* self, gint64 subscription_id, FeedbinAPISubscription* result, GError** error) {
	JsonNode* root = NULL;
	gint64 _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	JsonNode* _tmp5_;
	JsonNode* _tmp6_;
	FeedbinAPISubscription _tmp7_ = {0};
	JsonNode* _tmp8_;
	JsonObject* _tmp9_;
	FeedbinAPISubscription _tmp10_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = subscription_id;
	_tmp1_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strconcat ("subscriptions/", _tmp2_, ".json", NULL);
	_tmp4_ = _tmp3_;
	_tmp5_ = feedbin_api_get_json (self, _tmp4_, &_inner_error_);
	_tmp6_ = _tmp5_;
	_g_free0 (_tmp4_);
	_g_free0 (_tmp2_);
	root = _tmp6_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == FEEDBIN_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp8_ = root;
	_tmp9_ = json_node_get_object (_tmp8_);
	feedbin_api_subscription_init_from_json (&_tmp7_, _tmp9_, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == FEEDBIN_ERROR) {
			g_propagate_error (error, _inner_error_);
			__vala_JsonNode_free0 (root);
			return;
		} else {
			__vala_JsonNode_free0 (root);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp10_ = _tmp7_;
	memset (&_tmp7_, 0, sizeof (FeedbinAPISubscription));
	*result = _tmp10_;
	feedbin_api_subscription_destroy (&_tmp7_);
	__vala_JsonNode_free0 (root);
	return;
}


static gpointer _json_array_ref0 (gpointer self) {
	return self ? json_array_ref (self) : NULL;
}


static gpointer _json_object_ref0 (gpointer self) {
	return self ? json_object_ref (self) : NULL;
}


GeeList* feedbin_api_get_subscriptions (FeedbinAPI* self, GError** error) {
	GeeList* result = NULL;
	JsonNode* root = NULL;
	JsonNode* _tmp0_;
	GeeArrayList* subscriptions = NULL;
	GeeArrayList* _tmp1_;
	JsonArray* array = NULL;
	JsonNode* _tmp2_;
	JsonArray* _tmp3_;
	JsonArray* _tmp4_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = feedbin_api_get_json (self, "subscriptions.json", &_inner_error_);
	root = _tmp0_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == FEEDBIN_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp1_ = gee_array_list_new (FEEDBIN_API_TYPE_SUBSCRIPTION, (GBoxedCopyFunc) feedbin_api_subscription_dup, (GDestroyNotify) feedbin_api_subscription_free, NULL, NULL, NULL);
	subscriptions = _tmp1_;
	_tmp2_ = root;
	_tmp3_ = json_node_get_array (_tmp2_);
	_tmp4_ = _json_array_ref0 (_tmp3_);
	array = _tmp4_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp5_ = FALSE;
			_tmp5_ = TRUE;
			while (TRUE) {
				gint _tmp7_;
				JsonArray* _tmp8_;
				guint _tmp9_;
				JsonObject* node = NULL;
				JsonArray* _tmp10_;
				gint _tmp11_;
				JsonObject* _tmp12_;
				JsonObject* _tmp13_;
				FeedbinAPISubscription _tmp14_ = {0};
				JsonObject* _tmp15_;
				GeeArrayList* _tmp16_;
				if (!_tmp5_) {
					gint _tmp6_;
					_tmp6_ = i;
					i = _tmp6_ + 1;
				}
				_tmp5_ = FALSE;
				_tmp7_ = i;
				_tmp8_ = array;
				_tmp9_ = json_array_get_length (_tmp8_);
				if (!(((guint) _tmp7_) < _tmp9_)) {
					break;
				}
				_tmp10_ = array;
				_tmp11_ = i;
				_tmp12_ = json_array_get_object_element (_tmp10_, (guint) _tmp11_);
				_tmp13_ = _json_object_ref0 (_tmp12_);
				node = _tmp13_;
				_tmp15_ = node;
				feedbin_api_subscription_init_from_json (&_tmp14_, _tmp15_, &_inner_error_);
				if (G_UNLIKELY (_inner_error_ != NULL)) {
					if (_inner_error_->domain == FEEDBIN_ERROR) {
						g_propagate_error (error, _inner_error_);
						_json_object_unref0 (node);
						_json_array_unref0 (array);
						_g_object_unref0 (subscriptions);
						__vala_JsonNode_free0 (root);
						return NULL;
					} else {
						_json_object_unref0 (node);
						_json_array_unref0 (array);
						_g_object_unref0 (subscriptions);
						__vala_JsonNode_free0 (root);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return NULL;
					}
				}
				_tmp16_ = subscriptions;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp16_, &_tmp14_);
				feedbin_api_subscription_destroy (&_tmp14_);
				_json_object_unref0 (node);
			}
		}
	}
	result = (GeeList*) subscriptions;
	_json_array_unref0 (array);
	__vala_JsonNode_free0 (root);
	return result;
}


void feedbin_api_delete_subscription (FeedbinAPI* self, gint64 subscription_id, GError** error) {
	gint64 _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	SoupMessage* _tmp5_;
	SoupMessage* _tmp6_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = subscription_id;
	_tmp1_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strconcat ("subscriptions/", _tmp2_, ".json", NULL);
	_tmp4_ = _tmp3_;
	_tmp5_ = feedbin_api_delete_request (self, _tmp4_, NULL, &_inner_error_);
	_tmp6_ = _tmp5_;
	_g_object_unref0 (_tmp6_);
	_g_free0 (_tmp4_);
	_g_free0 (_tmp2_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == FEEDBIN_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


static gpointer _feedbin_api_subscription_dup0 (gpointer self) {
	return self ? feedbin_api_subscription_dup (self) : NULL;
}


FeedbinAPISubscription* feedbin_api_add_subscription (FeedbinAPI* self, const gchar* url, GError** error) {
	FeedbinAPISubscription* result = NULL;
	JsonObject* object = NULL;
	JsonObject* _tmp0_;
	JsonObject* _tmp1_;
	const gchar* _tmp2_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (url != NULL, NULL);
	_tmp0_ = json_object_new ();
	object = _tmp0_;
	_tmp1_ = object;
	_tmp2_ = url;
	json_object_set_string_member (_tmp1_, "feed_url", _tmp2_);
	{
		SoupMessage* response = NULL;
		JsonObject* _tmp3_;
		SoupMessage* _tmp4_;
		SoupMessage* _tmp5_;
		guint _tmp6_;
		guint _tmp7_;
		JsonNode* root = NULL;
		SoupMessage* _tmp9_;
		JsonNode* _tmp10_;
		FeedbinAPISubscription _tmp11_ = {0};
		JsonNode* _tmp12_;
		JsonObject* _tmp13_;
		FeedbinAPISubscription _tmp14_;
		FeedbinAPISubscription _tmp15_;
		FeedbinAPISubscription* _tmp16_;
		FeedbinAPISubscription* _tmp17_;
		_tmp3_ = object;
		_tmp4_ = feedbin_api_post_json_object (self, "subscriptions.json", _tmp3_, &_inner_error_);
		response = _tmp4_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (g_error_matches (_inner_error_, FEEDBIN_ERROR, FEEDBIN_ERROR_NOT_FOUND)) {
				goto __catch2_feedbin_error_not_found;
			}
			goto __finally2;
		}
		_tmp5_ = response;
		g_object_get (_tmp5_, "status-code", &_tmp6_, NULL);
		_tmp7_ = _tmp6_;
		if (_tmp7_ == ((guint) 300)) {
			GError* _tmp8_;
			_tmp8_ = g_error_new_literal (FEEDBIN_ERROR, FEEDBIN_ERROR_MULTIPLE_CHOICES, "Site $url has multiple feeds to subscribe to");
			_inner_error_ = _tmp8_;
			_g_object_unref0 (response);
			if (g_error_matches (_inner_error_, FEEDBIN_ERROR, FEEDBIN_ERROR_NOT_FOUND)) {
				goto __catch2_feedbin_error_not_found;
			}
			goto __finally2;
		}
		_tmp9_ = response;
		_tmp10_ = feedbin_api_parse_json (_tmp9_, &_inner_error_);
		root = _tmp10_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (response);
			if (g_error_matches (_inner_error_, FEEDBIN_ERROR, FEEDBIN_ERROR_NOT_FOUND)) {
				goto __catch2_feedbin_error_not_found;
			}
			goto __finally2;
		}
		_tmp12_ = root;
		_tmp13_ = json_node_get_object (_tmp12_);
		feedbin_api_subscription_init_from_json (&_tmp11_, _tmp13_, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			__vala_JsonNode_free0 (root);
			_g_object_unref0 (response);
			if (g_error_matches (_inner_error_, FEEDBIN_ERROR, FEEDBIN_ERROR_NOT_FOUND)) {
				goto __catch2_feedbin_error_not_found;
			}
			goto __finally2;
		}
		_tmp14_ = _tmp11_;
		memset (&_tmp11_, 0, sizeof (FeedbinAPISubscription));
		_tmp15_ = _tmp14_;
		_tmp16_ = _feedbin_api_subscription_dup0 (&_tmp15_);
		_tmp17_ = _tmp16_;
		feedbin_api_subscription_destroy (&_tmp15_);
		result = _tmp17_;
		feedbin_api_subscription_destroy (&_tmp11_);
		__vala_JsonNode_free0 (root);
		_g_object_unref0 (response);
		_json_object_unref0 (object);
		return result;
	}
	goto __finally2;
	__catch2_feedbin_error_not_found:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		result = NULL;
		_g_error_free0 (e);
		_json_object_unref0 (object);
		return result;
	}
	__finally2:
	if (_inner_error_->domain == FEEDBIN_ERROR) {
		g_propagate_error (error, _inner_error_);
		_json_object_unref0 (object);
		return NULL;
	} else {
		_json_object_unref0 (object);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_json_object_unref0 (object);
}


void feedbin_api_rename_subscription (FeedbinAPI* self, gint64 subscription_id, const gchar* title, GError** error) {
	JsonObject* object = NULL;
	JsonObject* _tmp0_;
	const gchar* _tmp1_;
	gint64 _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	SoupMessage* _tmp7_;
	SoupMessage* _tmp8_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (title != NULL);
	_tmp0_ = json_object_new ();
	object = _tmp0_;
	_tmp1_ = title;
	json_object_set_string_member (object, "title", _tmp1_);
	_tmp2_ = subscription_id;
	_tmp3_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_strconcat ("subscriptions/", _tmp4_, "/update.json", NULL);
	_tmp6_ = _tmp5_;
	_tmp7_ = feedbin_api_post_json_object (self, _tmp6_, object, &_inner_error_);
	_tmp8_ = _tmp7_;
	_g_object_unref0 (_tmp8_);
	_g_free0 (_tmp6_);
	_g_free0 (_tmp4_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == FEEDBIN_ERROR) {
			g_propagate_error (error, _inner_error_);
			_json_object_unref0 (object);
			return;
		} else {
			_json_object_unref0 (object);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_json_object_unref0 (object);
}


void feedbin_api_add_tagging (FeedbinAPI* self, gint64 feed_id, const gchar* tag_name, GError** error) {
	JsonObject* object = NULL;
	JsonObject* _tmp0_;
	gint64 _tmp1_;
	const gchar* _tmp2_;
	SoupMessage* _tmp3_;
	SoupMessage* _tmp4_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (tag_name != NULL);
	_tmp0_ = json_object_new ();
	object = _tmp0_;
	_tmp1_ = feed_id;
	json_object_set_int_member (object, "feed_id", _tmp1_);
	_tmp2_ = tag_name;
	json_object_set_string_member (object, "name", _tmp2_);
	_tmp3_ = feedbin_api_post_json_object (self, "taggings.json", object, &_inner_error_);
	_tmp4_ = _tmp3_;
	_g_object_unref0 (_tmp4_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == FEEDBIN_ERROR) {
			g_propagate_error (error, _inner_error_);
			_json_object_unref0 (object);
			return;
		} else {
			_json_object_unref0 (object);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_json_object_unref0 (object);
}


void feedbin_api_delete_tagging (FeedbinAPI* self, gint64 tagging_id, GError** error) {
	gint64 _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	SoupMessage* _tmp5_;
	SoupMessage* _tmp6_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = tagging_id;
	_tmp1_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strconcat ("taggings/", _tmp2_, ".json", NULL);
	_tmp4_ = _tmp3_;
	_tmp5_ = feedbin_api_delete_request (self, _tmp4_, NULL, &_inner_error_);
	_tmp6_ = _tmp5_;
	_g_object_unref0 (_tmp6_);
	_g_free0 (_tmp4_);
	_g_free0 (_tmp2_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == FEEDBIN_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


GeeList* feedbin_api_get_taggings (FeedbinAPI* self, GError** error) {
	GeeList* result = NULL;
	JsonNode* root = NULL;
	JsonNode* _tmp0_;
	GeeArrayList* taggings = NULL;
	GeeArrayList* _tmp1_;
	JsonArray* array = NULL;
	JsonArray* _tmp2_;
	JsonArray* _tmp3_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = feedbin_api_get_json (self, "taggings.json", &_inner_error_);
	root = _tmp0_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == FEEDBIN_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp1_ = gee_array_list_new (FEEDBIN_API_TYPE_TAGGING, (GBoxedCopyFunc) feedbin_api_tagging_dup, (GDestroyNotify) feedbin_api_tagging_free, NULL, NULL, NULL);
	taggings = _tmp1_;
	_tmp2_ = json_node_get_array (root);
	_tmp3_ = _json_array_ref0 (_tmp2_);
	array = _tmp3_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp4_ = FALSE;
			_tmp4_ = TRUE;
			while (TRUE) {
				gint _tmp6_;
				JsonArray* _tmp7_;
				guint _tmp8_;
				JsonObject* object = NULL;
				JsonArray* _tmp9_;
				gint _tmp10_;
				JsonObject* _tmp11_;
				JsonObject* _tmp12_;
				GeeArrayList* _tmp13_;
				JsonObject* _tmp14_;
				FeedbinAPITagging _tmp15_ = {0};
				FeedbinAPITagging _tmp16_;
				FeedbinAPITagging _tmp17_;
				if (!_tmp4_) {
					gint _tmp5_;
					_tmp5_ = i;
					i = _tmp5_ + 1;
				}
				_tmp4_ = FALSE;
				_tmp6_ = i;
				_tmp7_ = array;
				_tmp8_ = json_array_get_length (_tmp7_);
				if (!(((guint) _tmp6_) < _tmp8_)) {
					break;
				}
				_tmp9_ = array;
				_tmp10_ = i;
				_tmp11_ = json_array_get_object_element (_tmp9_, (guint) _tmp10_);
				_tmp12_ = _json_object_ref0 (_tmp11_);
				object = _tmp12_;
				_tmp13_ = taggings;
				_tmp14_ = object;
				feedbin_api_tagging_init_from_json (&_tmp15_, _tmp14_);
				_tmp16_ = _tmp15_;
				_tmp17_ = _tmp16_;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp13_, &_tmp17_);
				feedbin_api_tagging_destroy (&_tmp16_);
				_json_object_unref0 (object);
			}
		}
	}
	result = (GeeList*) taggings;
	_json_array_unref0 (array);
	__vala_JsonNode_free0 (root);
	return result;
}


GeeList* feedbin_api_get_entries (FeedbinAPI* self, gint page, gboolean only_starred, GDateTime* since, gint64* feed_id, GError** error) {
	GeeList* result = NULL;
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_;
	gchar* starred = NULL;
	gchar* _tmp2_;
	gchar* path = NULL;
	gint _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	GDateTime* _tmp10_;
	gint64* _tmp20_;
	JsonNode* root = NULL;
	GeeArrayList* entries = NULL;
	GeeArrayList* _tmp32_;
	JsonArray* array = NULL;
	JsonNode* _tmp33_;
	JsonArray* _tmp34_;
	JsonArray* _tmp35_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = only_starred;
	if (_tmp1_) {
		_tmp0_ = "true";
	} else {
		_tmp0_ = "false";
	}
	_tmp2_ = g_strdup (_tmp0_);
	starred = _tmp2_;
	_tmp3_ = page;
	_tmp4_ = g_strdup_printf ("%i", _tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = starred;
	_tmp7_ = string_to_string (_tmp6_);
	_tmp8_ = g_strconcat ("entries.json?per_page=100&page=", _tmp5_, "&starred=", _tmp7_, "&include_enclosure=true", NULL);
	_tmp9_ = _tmp8_;
	_g_free0 (_tmp5_);
	path = _tmp9_;
	_tmp10_ = since;
	if (_tmp10_ != NULL) {
		GTimeVal t = {0};
		GDateTime* _tmp11_;
		GTimeVal _tmp12_ = {0};
		gboolean _tmp13_;
		g_get_current_time (&t);
		_tmp11_ = since;
		_tmp13_ = g_date_time_to_timeval (_tmp11_, &_tmp12_);
		t = _tmp12_;
		if (_tmp13_) {
			const gchar* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
			_tmp14_ = path;
			_tmp15_ = g_time_val_to_iso8601 (&t);
			_tmp16_ = _tmp15_;
			_tmp17_ = g_strconcat ("&since=", _tmp16_, NULL);
			_tmp18_ = _tmp17_;
			_tmp19_ = g_strconcat (_tmp14_, _tmp18_, NULL);
			_g_free0 (path);
			path = _tmp19_;
			_g_free0 (_tmp18_);
			_g_free0 (_tmp16_);
		}
	}
	_tmp20_ = feed_id;
	if (_tmp20_ != NULL) {
		gint64* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		const gchar* _tmp24_;
		const gchar* _tmp25_;
		gchar* _tmp26_;
		_tmp21_ = feed_id;
		_tmp22_ = g_strdup_printf ("%" G_GINT64_FORMAT, *_tmp21_);
		_tmp23_ = _tmp22_;
		_tmp24_ = path;
		_tmp25_ = string_to_string (_tmp24_);
		_tmp26_ = g_strconcat ("feeds/", _tmp23_, "/", _tmp25_, NULL);
		_g_free0 (path);
		path = _tmp26_;
		_g_free0 (_tmp23_);
	}
	{
		JsonNode* _tmp27_ = NULL;
		const gchar* _tmp28_;
		JsonNode* _tmp29_;
		JsonNode* _tmp30_;
		_tmp28_ = path;
		_tmp29_ = feedbin_api_get_json (self, _tmp28_, &_inner_error_);
		_tmp27_ = _tmp29_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (g_error_matches (_inner_error_, FEEDBIN_ERROR, FEEDBIN_ERROR_NOT_FOUND)) {
				goto __catch3_feedbin_error_not_found;
			}
			goto __finally3;
		}
		_tmp30_ = _tmp27_;
		_tmp27_ = NULL;
		__vala_JsonNode_free0 (root);
		root = _tmp30_;
		__vala_JsonNode_free0 (_tmp27_);
	}
	goto __finally3;
	__catch3_feedbin_error_not_found:
	{
		GError* e = NULL;
		GeeList* _tmp31_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp31_ = gee_list_empty (FEEDBIN_API_TYPE_ENTRY, (GBoxedCopyFunc) feedbin_api_entry_dup, (GDestroyNotify) feedbin_api_entry_free);
		result = _tmp31_;
		_g_error_free0 (e);
		__vala_JsonNode_free0 (root);
		_g_free0 (path);
		_g_free0 (starred);
		return result;
	}
	__finally3:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == FEEDBIN_ERROR) {
			g_propagate_error (error, _inner_error_);
			__vala_JsonNode_free0 (root);
			_g_free0 (path);
			_g_free0 (starred);
			return NULL;
		} else {
			__vala_JsonNode_free0 (root);
			_g_free0 (path);
			_g_free0 (starred);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp32_ = gee_array_list_new (FEEDBIN_API_TYPE_ENTRY, (GBoxedCopyFunc) feedbin_api_entry_dup, (GDestroyNotify) feedbin_api_entry_free, NULL, NULL, NULL);
	entries = _tmp32_;
	_tmp33_ = root;
	_tmp34_ = json_node_get_array (_tmp33_);
	_tmp35_ = _json_array_ref0 (_tmp34_);
	array = _tmp35_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp36_ = FALSE;
			_tmp36_ = TRUE;
			while (TRUE) {
				gint _tmp38_;
				JsonArray* _tmp39_;
				guint _tmp40_;
				JsonObject* object = NULL;
				JsonArray* _tmp41_;
				gint _tmp42_;
				JsonObject* _tmp43_;
				JsonObject* _tmp44_;
				FeedbinAPIEntry _tmp45_ = {0};
				JsonObject* _tmp46_;
				GeeArrayList* _tmp47_;
				if (!_tmp36_) {
					gint _tmp37_;
					_tmp37_ = i;
					i = _tmp37_ + 1;
				}
				_tmp36_ = FALSE;
				_tmp38_ = i;
				_tmp39_ = array;
				_tmp40_ = json_array_get_length (_tmp39_);
				if (!(((guint) _tmp38_) < _tmp40_)) {
					break;
				}
				_tmp41_ = array;
				_tmp42_ = i;
				_tmp43_ = json_array_get_object_element (_tmp41_, (guint) _tmp42_);
				_tmp44_ = _json_object_ref0 (_tmp43_);
				object = _tmp44_;
				_tmp46_ = object;
				feedbin_api_entry_init_from_json (&_tmp45_, _tmp46_, &_inner_error_);
				if (G_UNLIKELY (_inner_error_ != NULL)) {
					if (_inner_error_->domain == FEEDBIN_ERROR) {
						g_propagate_error (error, _inner_error_);
						_json_object_unref0 (object);
						_json_array_unref0 (array);
						_g_object_unref0 (entries);
						__vala_JsonNode_free0 (root);
						_g_free0 (path);
						_g_free0 (starred);
						return NULL;
					} else {
						_json_object_unref0 (object);
						_json_array_unref0 (array);
						_g_object_unref0 (entries);
						__vala_JsonNode_free0 (root);
						_g_free0 (path);
						_g_free0 (starred);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return NULL;
					}
				}
				_tmp47_ = entries;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp47_, &_tmp45_);
				feedbin_api_entry_destroy (&_tmp45_);
				_json_object_unref0 (object);
			}
		}
	}
	result = (GeeList*) entries;
	_json_array_unref0 (array);
	__vala_JsonNode_free0 (root);
	_g_free0 (path);
	_g_free0 (starred);
	return result;
}


static guint __lambda4_ (FeedbinAPI* self, gint64* n) {
	guint result = 0U;
	GHashFunc _tmp0_;
	gint64* _tmp1_;
	guint _tmp2_;
	_tmp0_ = g_int64_hash;
	_tmp1_ = n;
	_tmp2_ = _tmp0_ (_tmp1_);
	result = _tmp2_;
	return result;
}


static guint ___lambda4__gee_hash_data_func (gconstpointer v, gpointer self) {
	guint result;
	result = __lambda4_ ((FeedbinAPI*) self, (gint64*) v);
	return result;
}


static gboolean __lambda5_ (FeedbinAPI* self, gint64* a, gint64* b) {
	gboolean result = FALSE;
	GEqualFunc _tmp0_;
	gint64* _tmp1_;
	gint64* _tmp2_;
	gboolean _tmp3_;
	_tmp0_ = g_int64_equal;
	_tmp1_ = a;
	_tmp2_ = b;
	_tmp3_ = _tmp0_ (_tmp1_, _tmp2_);
	result = _tmp3_;
	return result;
}


static gboolean ___lambda5__gee_equal_data_func (gconstpointer a, gconstpointer b, gpointer self) {
	gboolean result;
	result = __lambda5_ ((FeedbinAPI*) self, (gint64*) a, (gint64*) b);
	return result;
}


static gint64* _int64_dup (gint64* self) {
	gint64* dup;
	dup = g_new0 (gint64, 1);
	memcpy (dup, self, sizeof (gint64));
	return dup;
}


static GeeSet* feedbin_api_get_x_entries (FeedbinAPI* self, const gchar* path, GError** error) {
	GeeSet* result = NULL;
	JsonNode* root = NULL;
	const gchar* _tmp0_;
	JsonNode* _tmp1_;
	JsonArray* array = NULL;
	JsonArray* _tmp2_;
	JsonArray* _tmp3_;
	GeeHashSet* ids = NULL;
	GeeHashSet* _tmp4_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (path != NULL, NULL);
	_tmp0_ = path;
	_tmp1_ = feedbin_api_get_json (self, _tmp0_, &_inner_error_);
	root = _tmp1_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == FEEDBIN_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp2_ = json_node_get_array (root);
	_tmp3_ = _json_array_ref0 (_tmp2_);
	array = _tmp3_;
	_tmp4_ = gee_hash_set_new (G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, (GDestroyNotify) g_free, ___lambda4__gee_hash_data_func, g_object_ref (self), g_object_unref, ___lambda5__gee_equal_data_func, g_object_ref (self), g_object_unref);
	ids = _tmp4_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp5_ = FALSE;
			_tmp5_ = TRUE;
			while (TRUE) {
				gint _tmp7_;
				JsonArray* _tmp8_;
				guint _tmp9_;
				GeeHashSet* _tmp10_;
				JsonArray* _tmp11_;
				gint _tmp12_;
				gint64 _tmp13_;
				if (!_tmp5_) {
					gint _tmp6_;
					_tmp6_ = i;
					i = _tmp6_ + 1;
				}
				_tmp5_ = FALSE;
				_tmp7_ = i;
				_tmp8_ = array;
				_tmp9_ = json_array_get_length (_tmp8_);
				if (!(((guint) _tmp7_) < _tmp9_)) {
					break;
				}
				_tmp10_ = ids;
				_tmp11_ = array;
				_tmp12_ = i;
				_tmp13_ = json_array_get_int_element (_tmp11_, (guint) _tmp12_);
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp10_, &_tmp13_);
			}
		}
	}
	result = (GeeSet*) ids;
	_json_array_unref0 (array);
	__vala_JsonNode_free0 (root);
	return result;
}


GeeSet* feedbin_api_get_unread_entries (FeedbinAPI* self, GError** error) {
	GeeSet* result = NULL;
	GeeSet* _tmp0_ = NULL;
	GeeSet* _tmp1_;
	GeeSet* _tmp2_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = feedbin_api_get_x_entries (self, "unread_entries.json", &_inner_error_);
	_tmp0_ = _tmp1_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == FEEDBIN_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp2_ = _tmp0_;
	_tmp0_ = NULL;
	result = _tmp2_;
	_g_object_unref0 (_tmp0_);
	return result;
}


GeeSet* feedbin_api_get_starred_entries (FeedbinAPI* self, GError** error) {
	GeeSet* result = NULL;
	GeeSet* _tmp0_ = NULL;
	GeeSet* _tmp1_;
	GeeSet* _tmp2_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = feedbin_api_get_x_entries (self, "starred_entries.json", &_inner_error_);
	_tmp0_ = _tmp1_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == FEEDBIN_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp2_ = _tmp0_;
	_tmp0_ = NULL;
	result = _tmp2_;
	_g_object_unref0 (_tmp0_);
	return result;
}


static void feedbin_api_set_entries_status (FeedbinAPI* self, const gchar* type, GeeCollection* entry_ids, gboolean create, GError** error) {
	JsonArray* array = NULL;
	JsonArray* _tmp0_;
	JsonObject* object = NULL;
	JsonObject* _tmp9_;
	JsonObject* _tmp10_;
	const gchar* _tmp11_;
	JsonArray* _tmp12_;
	JsonArray* _tmp13_;
	gchar* _tmp14_ = NULL;
	gboolean _tmp15_;
	gchar* path = NULL;
	gchar* _tmp22_;
	JsonObject* _tmp23_;
	SoupMessage* _tmp24_;
	SoupMessage* _tmp25_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (type != NULL);
	g_return_if_fail (entry_ids != NULL);
	_tmp0_ = json_array_new ();
	array = _tmp0_;
	{
		GeeIterator* _id_it = NULL;
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_;
		_tmp1_ = entry_ids;
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
		_id_it = _tmp2_;
		while (TRUE) {
			GeeIterator* _tmp3_;
			gboolean _tmp4_;
			gint64* id = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			JsonArray* _tmp7_;
			gint64* _tmp8_;
			_tmp3_ = _id_it;
			_tmp4_ = gee_iterator_next (_tmp3_);
			if (!_tmp4_) {
				break;
			}
			_tmp5_ = _id_it;
			_tmp6_ = gee_iterator_get (_tmp5_);
			id = (gint64*) _tmp6_;
			_tmp7_ = array;
			_tmp8_ = id;
			json_array_add_int_element (_tmp7_, *_tmp8_);
			_g_free0 (id);
		}
		_g_object_unref0 (_id_it);
	}
	_tmp9_ = json_object_new ();
	object = _tmp9_;
	_tmp10_ = object;
	_tmp11_ = type;
	_tmp12_ = array;
	_tmp13_ = _json_array_ref0 (_tmp12_);
	json_object_set_array_member (_tmp10_, _tmp11_, _tmp13_);
	_tmp15_ = create;
	if (_tmp15_) {
		const gchar* _tmp16_;
		const gchar* _tmp17_;
		gchar* _tmp18_;
		_tmp16_ = type;
		_tmp17_ = string_to_string (_tmp16_);
		_tmp18_ = g_strconcat (_tmp17_, ".json", NULL);
		_g_free0 (_tmp14_);
		_tmp14_ = _tmp18_;
	} else {
		const gchar* _tmp19_;
		const gchar* _tmp20_;
		gchar* _tmp21_;
		_tmp19_ = type;
		_tmp20_ = string_to_string (_tmp19_);
		_tmp21_ = g_strconcat (_tmp20_, "/delete.json", NULL);
		_g_free0 (_tmp14_);
		_tmp14_ = _tmp21_;
	}
	_tmp22_ = g_strdup (_tmp14_);
	path = _tmp22_;
	_tmp23_ = object;
	_tmp24_ = feedbin_api_post_json_object (self, path, _tmp23_, &_inner_error_);
	_tmp25_ = _tmp24_;
	_g_object_unref0 (_tmp25_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == FEEDBIN_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_free0 (path);
			_g_free0 (_tmp14_);
			_json_object_unref0 (object);
			_json_array_unref0 (array);
			return;
		} else {
			_g_free0 (path);
			_g_free0 (_tmp14_);
			_json_object_unref0 (object);
			_json_array_unref0 (array);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_g_free0 (path);
	_g_free0 (_tmp14_);
	_json_object_unref0 (object);
	_json_array_unref0 (array);
}


void feedbin_api_set_entries_read (FeedbinAPI* self, GeeCollection* entry_ids, gboolean read, GError** error) {
	GeeCollection* _tmp0_;
	gboolean _tmp1_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (entry_ids != NULL);
	_tmp0_ = entry_ids;
	_tmp1_ = read;
	feedbin_api_set_entries_status (self, "unread_entries", _tmp0_, !_tmp1_, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == FEEDBIN_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


void feedbin_api_set_entries_starred (FeedbinAPI* self, GeeCollection* entry_ids, gboolean starred, GError** error) {
	GeeCollection* _tmp0_;
	gboolean _tmp1_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (entry_ids != NULL);
	_tmp0_ = entry_ids;
	_tmp1_ = starred;
	feedbin_api_set_entries_status (self, "starred_entries", _tmp0_, _tmp1_, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == FEEDBIN_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


GeeMap* feedbin_api_get_favicons (FeedbinAPI* self, GError** error) {
	GeeMap* result = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	{
		JsonNode* root = NULL;
		JsonNode* _tmp0_;
		JsonNode* _tmp1_;
		JsonArray* array = NULL;
		JsonNode* _tmp3_;
		JsonArray* _tmp4_;
		JsonArray* _tmp5_;
		JsonArray* _tmp6_;
		GeeHashMap* favicons = NULL;
		GeeHashMap* _tmp8_;
		_tmp0_ = feedbin_api_get_json (self, "favicons.json", &_inner_error_);
		root = _tmp0_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch4_g_error;
		}
		_tmp1_ = root;
		if (_tmp1_ == NULL) {
			GeeMap* _tmp2_;
			_tmp2_ = gee_map_empty (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_BYTES, (GBoxedCopyFunc) g_bytes_ref, (GDestroyNotify) g_bytes_unref);
			result = _tmp2_;
			__vala_JsonNode_free0 (root);
			return result;
		}
		_tmp3_ = root;
		_tmp4_ = json_node_get_array (_tmp3_);
		_tmp5_ = _json_array_ref0 (_tmp4_);
		array = _tmp5_;
		_tmp6_ = array;
		if (_tmp6_ == NULL) {
			GeeMap* _tmp7_;
			_tmp7_ = gee_map_empty (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_BYTES, (GBoxedCopyFunc) g_bytes_ref, (GDestroyNotify) g_bytes_unref);
			result = _tmp7_;
			_json_array_unref0 (array);
			__vala_JsonNode_free0 (root);
			return result;
		}
		_tmp8_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_BYTES, (GBoxedCopyFunc) g_bytes_ref, (GDestroyNotify) g_bytes_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
		favicons = _tmp8_;
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp9_ = FALSE;
				_tmp9_ = TRUE;
				while (TRUE) {
					gint _tmp11_;
					JsonArray* _tmp12_;
					guint _tmp13_;
					JsonObject* obj = NULL;
					JsonArray* _tmp14_;
					gint _tmp15_;
					JsonObject* _tmp16_;
					JsonObject* _tmp17_;
					gchar* host = NULL;
					JsonObject* _tmp18_;
					const gchar* _tmp19_;
					gchar* _tmp20_;
					const gchar* _tmp21_;
					gchar* favicon_encoded = NULL;
					JsonObject* _tmp22_;
					const gchar* _tmp23_;
					gchar* _tmp24_;
					const gchar* _tmp25_;
					GBytes* favicon = NULL;
					const gchar* _tmp26_;
					size_t _tmp27_;
					guchar* _tmp28_;
					GBytes* _tmp29_;
					GeeHashMap* _tmp30_;
					const gchar* _tmp31_;
					GBytes* _tmp32_;
					if (!_tmp9_) {
						gint _tmp10_;
						_tmp10_ = i;
						i = _tmp10_ + 1;
					}
					_tmp9_ = FALSE;
					_tmp11_ = i;
					_tmp12_ = array;
					_tmp13_ = json_array_get_length (_tmp12_);
					if (!(((guint) _tmp11_) < _tmp13_)) {
						break;
					}
					_tmp14_ = array;
					_tmp15_ = i;
					_tmp16_ = json_array_get_object_element (_tmp14_, (guint) _tmp15_);
					_tmp17_ = _json_object_ref0 (_tmp16_);
					obj = _tmp17_;
					_tmp18_ = obj;
					_tmp19_ = json_object_get_string_member (_tmp18_, "host");
					_tmp20_ = g_strdup (_tmp19_);
					host = _tmp20_;
					_tmp21_ = host;
					if (_tmp21_ == NULL) {
						_g_free0 (host);
						_json_object_unref0 (obj);
						continue;
					}
					_tmp22_ = obj;
					_tmp23_ = json_object_get_string_member (_tmp22_, "favicon");
					_tmp24_ = g_strdup (_tmp23_);
					favicon_encoded = _tmp24_;
					_tmp25_ = favicon_encoded;
					if (_tmp25_ == NULL) {
						_g_free0 (favicon_encoded);
						_g_free0 (host);
						_json_object_unref0 (obj);
						continue;
					}
					_tmp26_ = favicon_encoded;
					_tmp28_ = g_base64_decode (_tmp26_, &_tmp27_);
					_tmp29_ = g_bytes_new_take (_tmp28_, _tmp27_);
					favicon = _tmp29_;
					_tmp30_ = favicons;
					_tmp31_ = host;
					_tmp32_ = favicon;
					gee_abstract_map_set ((GeeAbstractMap*) _tmp30_, _tmp31_, _tmp32_);
					_g_bytes_unref0 (favicon);
					_g_free0 (favicon_encoded);
					_g_free0 (host);
					_json_object_unref0 (obj);
				}
			}
		}
		result = (GeeMap*) favicons;
		_json_array_unref0 (array);
		__vala_JsonNode_free0 (root);
		return result;
	}
	goto __finally4;
	__catch4_g_error:
	{
		GError* e = NULL;
		GeeMap* _tmp33_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp33_ = gee_map_empty (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_BYTES, (GBoxedCopyFunc) g_bytes_ref, (GDestroyNotify) g_bytes_unref);
		result = _tmp33_;
		_g_error_free0 (e);
		return result;
	}
	__finally4:
	if (_inner_error_->domain == FEEDBIN_ERROR) {
		g_propagate_error (error, _inner_error_);
		return NULL;
	} else {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


const gchar* feedbin_api_get_username (FeedbinAPI* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_username;
	result = _tmp0_;
	return result;
}


void feedbin_api_set_username (FeedbinAPI* self, const gchar* value) {
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, feedbin_api_get_username (self)) != 0) {
		const gchar* _tmp0_;
		gchar* _tmp1_;
		_tmp0_ = value;
		_tmp1_ = g_strdup (_tmp0_);
		_g_free0 (self->priv->_username);
		self->priv->_username = _tmp1_;
		g_object_notify_by_pspec ((GObject *) self, feedbin_api_properties[FEEDBIN_API_USERNAME_PROPERTY]);
	}
}


const gchar* feedbin_api_get_password (FeedbinAPI* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_password;
	result = _tmp0_;
	return result;
}


void feedbin_api_set_password (FeedbinAPI* self, const gchar* value) {
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, feedbin_api_get_password (self)) != 0) {
		const gchar* _tmp0_;
		gchar* _tmp1_;
		_tmp0_ = value;
		_tmp1_ = g_strdup (_tmp0_);
		_g_free0 (self->priv->_password);
		self->priv->_password = _tmp1_;
		g_object_notify_by_pspec ((GObject *) self, feedbin_api_properties[FEEDBIN_API_PASSWORD_PROPERTY]);
	}
}


void feedbin_api_subscription_init_from_json (FeedbinAPISubscription *self, JsonObject* object, GError** error) {
	JsonObject* _tmp0_;
	gint64 _tmp1_;
	GDateTime* _tmp2_ = NULL;
	JsonObject* _tmp3_;
	GDateTime* _tmp4_;
	GDateTime* _tmp5_;
	JsonObject* _tmp6_;
	gint64 _tmp7_;
	JsonObject* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	JsonObject* _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	JsonObject* _tmp14_;
	const gchar* _tmp15_;
	gchar* _tmp16_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (object != NULL);
	memset (self, 0, sizeof (FeedbinAPISubscription));
	_tmp0_ = object;
	_tmp1_ = json_object_get_int_member (_tmp0_, "id");
	(*self).id = _tmp1_;
	_tmp3_ = object;
	_tmp4_ = feedbin_api_get_datetime_member (_tmp3_, "created_at", &_inner_error_);
	_tmp2_ = _tmp4_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == FEEDBIN_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp5_ = _tmp2_;
	_tmp2_ = NULL;
	_g_date_time_unref0 ((*self).created_at);
	(*self).created_at = _tmp5_;
	_tmp6_ = object;
	_tmp7_ = json_object_get_int_member (_tmp6_, "feed_id");
	(*self).feed_id = _tmp7_;
	_tmp8_ = object;
	_tmp9_ = json_object_get_string_member (_tmp8_, "title");
	_tmp10_ = g_strdup (_tmp9_);
	_g_free0 ((*self).title);
	(*self).title = _tmp10_;
	_tmp11_ = object;
	_tmp12_ = json_object_get_string_member (_tmp11_, "feed_url");
	_tmp13_ = g_strdup (_tmp12_);
	_g_free0 ((*self).feed_url);
	(*self).feed_url = _tmp13_;
	_tmp14_ = object;
	_tmp15_ = json_object_get_string_member (_tmp14_, "site_url");
	_tmp16_ = g_strdup (_tmp15_);
	_g_free0 ((*self).site_url);
	(*self).site_url = _tmp16_;
	_g_date_time_unref0 (_tmp2_);
}


static gpointer _g_date_time_ref0 (gpointer self) {
	return self ? g_date_time_ref (self) : NULL;
}


void feedbin_api_subscription_copy (const FeedbinAPISubscription* self, FeedbinAPISubscription* dest) {
	gint64 _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	gint64 _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	_tmp0_ = (*self).id;
	(*dest).id = _tmp0_;
	_tmp1_ = (*self).created_at;
	_tmp2_ = _g_date_time_ref0 (_tmp1_);
	_g_date_time_unref0 ((*dest).created_at);
	(*dest).created_at = _tmp2_;
	_tmp3_ = (*self).feed_id;
	(*dest).feed_id = _tmp3_;
	_tmp4_ = (*self).title;
	_tmp5_ = g_strdup (_tmp4_);
	_g_free0 ((*dest).title);
	(*dest).title = _tmp5_;
	_tmp6_ = (*self).feed_url;
	_tmp7_ = g_strdup (_tmp6_);
	_g_free0 ((*dest).feed_url);
	(*dest).feed_url = _tmp7_;
	_tmp8_ = (*self).site_url;
	_tmp9_ = g_strdup (_tmp8_);
	_g_free0 ((*dest).site_url);
	(*dest).site_url = _tmp9_;
}


void feedbin_api_subscription_destroy (FeedbinAPISubscription* self) {
	_g_date_time_unref0 ((*self).created_at);
	_g_free0 ((*self).title);
	_g_free0 ((*self).feed_url);
	_g_free0 ((*self).site_url);
}


FeedbinAPISubscription* feedbin_api_subscription_dup (const FeedbinAPISubscription* self) {
	FeedbinAPISubscription* dup;
	dup = g_new0 (FeedbinAPISubscription, 1);
	feedbin_api_subscription_copy (self, dup);
	return dup;
}


void feedbin_api_subscription_free (FeedbinAPISubscription* self) {
	feedbin_api_subscription_destroy (self);
	g_free (self);
}


GType feedbin_api_subscription_get_type (void) {
	static volatile gsize feedbin_api_subscription_type_id__volatile = 0;
	if (g_once_init_enter (&feedbin_api_subscription_type_id__volatile)) {
		GType feedbin_api_subscription_type_id;
		feedbin_api_subscription_type_id = g_boxed_type_register_static ("FeedbinAPISubscription", (GBoxedCopyFunc) feedbin_api_subscription_dup, (GBoxedFreeFunc) feedbin_api_subscription_free);
		g_once_init_leave (&feedbin_api_subscription_type_id__volatile, feedbin_api_subscription_type_id);
	}
	return feedbin_api_subscription_type_id__volatile;
}


void feedbin_api_tagging_init_from_json (FeedbinAPITagging *self, JsonObject* object) {
	JsonObject* _tmp0_;
	gint64 _tmp1_;
	JsonObject* _tmp2_;
	gint64 _tmp3_;
	JsonObject* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	g_return_if_fail (object != NULL);
	memset (self, 0, sizeof (FeedbinAPITagging));
	_tmp0_ = object;
	_tmp1_ = json_object_get_int_member (_tmp0_, "id");
	(*self).id = _tmp1_;
	_tmp2_ = object;
	_tmp3_ = json_object_get_int_member (_tmp2_, "feed_id");
	(*self).feed_id = _tmp3_;
	_tmp4_ = object;
	_tmp5_ = json_object_get_string_member (_tmp4_, "name");
	_tmp6_ = g_strdup (_tmp5_);
	_g_free0 ((*self).name);
	(*self).name = _tmp6_;
}


void feedbin_api_tagging_copy (const FeedbinAPITagging* self, FeedbinAPITagging* dest) {
	gint64 _tmp0_;
	gint64 _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	_tmp0_ = (*self).id;
	(*dest).id = _tmp0_;
	_tmp1_ = (*self).feed_id;
	(*dest).feed_id = _tmp1_;
	_tmp2_ = (*self).name;
	_tmp3_ = g_strdup (_tmp2_);
	_g_free0 ((*dest).name);
	(*dest).name = _tmp3_;
}


void feedbin_api_tagging_destroy (FeedbinAPITagging* self) {
	_g_free0 ((*self).name);
}


FeedbinAPITagging* feedbin_api_tagging_dup (const FeedbinAPITagging* self) {
	FeedbinAPITagging* dup;
	dup = g_new0 (FeedbinAPITagging, 1);
	feedbin_api_tagging_copy (self, dup);
	return dup;
}


void feedbin_api_tagging_free (FeedbinAPITagging* self) {
	feedbin_api_tagging_destroy (self);
	g_free (self);
}


GType feedbin_api_tagging_get_type (void) {
	static volatile gsize feedbin_api_tagging_type_id__volatile = 0;
	if (g_once_init_enter (&feedbin_api_tagging_type_id__volatile)) {
		GType feedbin_api_tagging_type_id;
		feedbin_api_tagging_type_id = g_boxed_type_register_static ("FeedbinAPITagging", (GBoxedCopyFunc) feedbin_api_tagging_dup, (GBoxedFreeFunc) feedbin_api_tagging_free);
		g_once_init_leave (&feedbin_api_tagging_type_id__volatile, feedbin_api_tagging_type_id);
	}
	return feedbin_api_tagging_type_id__volatile;
}


void feedbin_api_entry_init_from_json (FeedbinAPIEntry *self, JsonObject* object, GError** error) {
	JsonObject* _tmp0_;
	gint64 _tmp1_;
	JsonObject* _tmp2_;
	gint64 _tmp3_;
	JsonObject* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	JsonObject* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	JsonObject* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	JsonObject* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	JsonObject* _tmp16_;
	const gchar* _tmp17_;
	gchar* _tmp18_;
	GDateTime* _tmp19_ = NULL;
	JsonObject* _tmp20_;
	GDateTime* _tmp21_;
	GDateTime* _tmp22_;
	GDateTime* _tmp23_ = NULL;
	JsonObject* _tmp24_;
	GDateTime* _tmp25_;
	GDateTime* _tmp26_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (object != NULL);
	memset (self, 0, sizeof (FeedbinAPIEntry));
	_tmp0_ = object;
	_tmp1_ = json_object_get_int_member (_tmp0_, "id");
	(*self).id = _tmp1_;
	_tmp2_ = object;
	_tmp3_ = json_object_get_int_member (_tmp2_, "feed_id");
	(*self).feed_id = _tmp3_;
	_tmp4_ = object;
	_tmp5_ = json_object_get_string_member (_tmp4_, "title");
	_tmp6_ = g_strdup (_tmp5_);
	_g_free0 ((*self).title);
	(*self).title = _tmp6_;
	_tmp7_ = object;
	_tmp8_ = json_object_get_string_member (_tmp7_, "url");
	_tmp9_ = g_strdup (_tmp8_);
	_g_free0 ((*self).url);
	(*self).url = _tmp9_;
	_tmp10_ = object;
	_tmp11_ = json_object_get_string_member (_tmp10_, "author");
	_tmp12_ = g_strdup (_tmp11_);
	_g_free0 ((*self).author);
	(*self).author = _tmp12_;
	_tmp13_ = object;
	_tmp14_ = json_object_get_string_member (_tmp13_, "content");
	_tmp15_ = g_strdup (_tmp14_);
	_g_free0 ((*self).content);
	(*self).content = _tmp15_;
	_tmp16_ = object;
	_tmp17_ = json_object_get_string_member (_tmp16_, "summary");
	_tmp18_ = g_strdup (_tmp17_);
	_g_free0 ((*self).summary);
	(*self).summary = _tmp18_;
	_tmp20_ = object;
	_tmp21_ = feedbin_api_get_datetime_member (_tmp20_, "published", &_inner_error_);
	_tmp19_ = _tmp21_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == FEEDBIN_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp22_ = _tmp19_;
	_tmp19_ = NULL;
	_g_date_time_unref0 ((*self).published);
	(*self).published = _tmp22_;
	_tmp24_ = object;
	_tmp25_ = feedbin_api_get_datetime_member (_tmp24_, "created_at", &_inner_error_);
	_tmp23_ = _tmp25_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == FEEDBIN_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_date_time_unref0 (_tmp19_);
			return;
		} else {
			_g_date_time_unref0 (_tmp19_);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp26_ = _tmp23_;
	_tmp23_ = NULL;
	_g_date_time_unref0 ((*self).created_at);
	(*self).created_at = _tmp26_;
	_g_date_time_unref0 (_tmp23_);
	_g_date_time_unref0 (_tmp19_);
}


void feedbin_api_entry_copy (const FeedbinAPIEntry* self, FeedbinAPIEntry* dest) {
	gint64 _tmp0_;
	gint64 _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	GDateTime* _tmp12_;
	GDateTime* _tmp13_;
	GDateTime* _tmp14_;
	GDateTime* _tmp15_;
	_tmp0_ = (*self).id;
	(*dest).id = _tmp0_;
	_tmp1_ = (*self).feed_id;
	(*dest).feed_id = _tmp1_;
	_tmp2_ = (*self).title;
	_tmp3_ = g_strdup (_tmp2_);
	_g_free0 ((*dest).title);
	(*dest).title = _tmp3_;
	_tmp4_ = (*self).url;
	_tmp5_ = g_strdup (_tmp4_);
	_g_free0 ((*dest).url);
	(*dest).url = _tmp5_;
	_tmp6_ = (*self).author;
	_tmp7_ = g_strdup (_tmp6_);
	_g_free0 ((*dest).author);
	(*dest).author = _tmp7_;
	_tmp8_ = (*self).content;
	_tmp9_ = g_strdup (_tmp8_);
	_g_free0 ((*dest).content);
	(*dest).content = _tmp9_;
	_tmp10_ = (*self).summary;
	_tmp11_ = g_strdup (_tmp10_);
	_g_free0 ((*dest).summary);
	(*dest).summary = _tmp11_;
	_tmp12_ = (*self).published;
	_tmp13_ = _g_date_time_ref0 (_tmp12_);
	_g_date_time_unref0 ((*dest).published);
	(*dest).published = _tmp13_;
	_tmp14_ = (*self).created_at;
	_tmp15_ = _g_date_time_ref0 (_tmp14_);
	_g_date_time_unref0 ((*dest).created_at);
	(*dest).created_at = _tmp15_;
}


void feedbin_api_entry_destroy (FeedbinAPIEntry* self) {
	_g_free0 ((*self).title);
	_g_free0 ((*self).url);
	_g_free0 ((*self).author);
	_g_free0 ((*self).content);
	_g_free0 ((*self).summary);
	_g_date_time_unref0 ((*self).published);
	_g_date_time_unref0 ((*self).created_at);
}


FeedbinAPIEntry* feedbin_api_entry_dup (const FeedbinAPIEntry* self) {
	FeedbinAPIEntry* dup;
	dup = g_new0 (FeedbinAPIEntry, 1);
	feedbin_api_entry_copy (self, dup);
	return dup;
}


void feedbin_api_entry_free (FeedbinAPIEntry* self) {
	feedbin_api_entry_destroy (self);
	g_free (self);
}


GType feedbin_api_entry_get_type (void) {
	static volatile gsize feedbin_api_entry_type_id__volatile = 0;
	if (g_once_init_enter (&feedbin_api_entry_type_id__volatile)) {
		GType feedbin_api_entry_type_id;
		feedbin_api_entry_type_id = g_boxed_type_register_static ("FeedbinAPIEntry", (GBoxedCopyFunc) feedbin_api_entry_dup, (GBoxedFreeFunc) feedbin_api_entry_free);
		g_once_init_leave (&feedbin_api_entry_type_id__volatile, feedbin_api_entry_type_id);
	}
	return feedbin_api_entry_type_id__volatile;
}


static void feedbin_api_class_init (FeedbinAPIClass * klass) {
	feedbin_api_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (FeedbinAPIPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_feedbin_api_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_feedbin_api_set_property;
	G_OBJECT_CLASS (klass)->finalize = feedbin_api_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), FEEDBIN_API_USERNAME_PROPERTY, feedbin_api_properties[FEEDBIN_API_USERNAME_PROPERTY] = g_param_spec_string ("username", "username", "username", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FEEDBIN_API_PASSWORD_PROPERTY, feedbin_api_properties[FEEDBIN_API_PASSWORD_PROPERTY] = g_param_spec_string ("password", "password", "password", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void feedbin_api_instance_init (FeedbinAPI * self) {
	self->priv = FEEDBIN_API_GET_PRIVATE (self);
}


static void feedbin_api_finalize (GObject * obj) {
	FeedbinAPI * self;
	SoupSession* _tmp0_;
	guint _tmp1_;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_FEEDBIN_API, FeedbinAPI);
	_tmp0_ = self->priv->m_session;
	g_signal_parse_name ("authenticate", soup_session_get_type (), &_tmp1_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _feedbin_api_authenticate_soup_session_authenticate, self);
	_g_object_unref0 (self->priv->m_session);
	_g_free0 (self->priv->m_base_uri);
	_g_free0 (self->priv->_username);
	_g_free0 (self->priv->_password);
	G_OBJECT_CLASS (feedbin_api_parent_class)->finalize (obj);
}


GType feedbin_api_get_type (void) {
	static volatile gsize feedbin_api_type_id__volatile = 0;
	if (g_once_init_enter (&feedbin_api_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (FeedbinAPIClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) feedbin_api_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FeedbinAPI), 0, (GInstanceInitFunc) feedbin_api_instance_init, NULL };
		GType feedbin_api_type_id;
		feedbin_api_type_id = g_type_register_static (G_TYPE_OBJECT, "FeedbinAPI", &g_define_type_info, 0);
		g_once_init_leave (&feedbin_api_type_id__volatile, feedbin_api_type_id);
	}
	return feedbin_api_type_id__volatile;
}


static void _vala_feedbin_api_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	FeedbinAPI * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_FEEDBIN_API, FeedbinAPI);
	switch (property_id) {
		case FEEDBIN_API_USERNAME_PROPERTY:
		g_value_set_string (value, feedbin_api_get_username (self));
		break;
		case FEEDBIN_API_PASSWORD_PROPERTY:
		g_value_set_string (value, feedbin_api_get_password (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_feedbin_api_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	FeedbinAPI * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_FEEDBIN_API, FeedbinAPI);
	switch (property_id) {
		case FEEDBIN_API_USERNAME_PROPERTY:
		feedbin_api_set_username (self, g_value_get_string (value));
		break;
		case FEEDBIN_API_PASSWORD_PROPERTY:
		feedbin_api_set_password (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



