/* Rfc822.c generated by valac 0.38.8, the Vala compiler
 * generated from Rfc822.vala, do not modify */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <float.h>
#include <math.h>

#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_match_info_unref0(var) ((var == NULL) ? NULL : (var = (g_match_info_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_time_zone_unref0(var) ((var == NULL) ? NULL : (var = (g_time_zone_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);



GDateTime* feed_reader_rfc822_parseDate (const gchar* str);


/**
 * Parse a date string in RFC 822 format
 * Note that we don't use Time.strptime because it uses the current locale
 * to parse month names, but RFC 822 specifically requires months to be
 * written in English.
     * See: https://www.w3.org/Protocols/rfc822/#z28
 * And: https://groups.yahoo.com/neo/groups/rss-public/conversations/topics/536
 * */
GDateTime* feed_reader_rfc822_parseDate (const gchar* str) {
	GDateTime* result = NULL;
	const gchar* _tmp0_;
	GRegex* re = NULL;
	GMatchInfo* info = NULL;
	GRegex* _tmp7_;
	const gchar* _tmp8_;
	GMatchInfo* _tmp9_ = NULL;
	gboolean _tmp10_;
	gchar* dayStr = NULL;
	GMatchInfo* _tmp11_;
	gchar* _tmp12_;
	gint day = 0;
	const gchar* _tmp13_;
	gint _tmp14_;
	gchar* monthStr = NULL;
	GMatchInfo* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gint month = 0;
	const gchar* _tmp20_;
	const gchar* _tmp21_;
	GQuark _tmp23_ = 0U;
	static GQuark _tmp22_label0 = 0;
	static GQuark _tmp22_label1 = 0;
	static GQuark _tmp22_label2 = 0;
	static GQuark _tmp22_label3 = 0;
	static GQuark _tmp22_label4 = 0;
	static GQuark _tmp22_label5 = 0;
	static GQuark _tmp22_label6 = 0;
	static GQuark _tmp22_label7 = 0;
	static GQuark _tmp22_label8 = 0;
	static GQuark _tmp22_label9 = 0;
	static GQuark _tmp22_label10 = 0;
	static GQuark _tmp22_label11 = 0;
	gchar* yearStr = NULL;
	GMatchInfo* _tmp24_;
	gchar* _tmp25_;
	gint year = 0;
	const gchar* _tmp26_;
	gint _tmp27_;
	gboolean _tmp28_ = FALSE;
	gint _tmp29_;
	gchar* hourStr = NULL;
	GMatchInfo* _tmp36_;
	gchar* _tmp37_;
	gint hour = 0;
	const gchar* _tmp38_;
	gint _tmp39_;
	gchar* minuteStr = NULL;
	GMatchInfo* _tmp40_;
	gchar* _tmp41_;
	gint minute = 0;
	const gchar* _tmp42_;
	gint _tmp43_;
	gchar* secondStr = NULL;
	GMatchInfo* _tmp44_;
	gchar* _tmp45_;
	gint _tmp46_ = 0;
	gboolean _tmp47_ = FALSE;
	const gchar* _tmp48_;
	gint second = 0;
	gchar* zoneStr = NULL;
	GMatchInfo* _tmp52_;
	gchar* _tmp53_;
	GTimeZone* zone = NULL;
	const gchar* _tmp54_;
	gchar* _tmp55_;
	gchar* _tmp56_;
	GQuark _tmp58_ = 0U;
	static GQuark _tmp57_label0 = 0;
	static GQuark _tmp57_label1 = 0;
	static GQuark _tmp57_label2 = 0;
	static GQuark _tmp57_label3 = 0;
	static GQuark _tmp57_label4 = 0;
	static GQuark _tmp57_label5 = 0;
	static GQuark _tmp57_label6 = 0;
	static GQuark _tmp57_label7 = 0;
	static GQuark _tmp57_label8 = 0;
	static GQuark _tmp57_label9 = 0;
	static GQuark _tmp57_label10 = 0;
	GTimeZone* _tmp67_;
	gint _tmp68_;
	gint _tmp69_;
	gint _tmp70_;
	gint _tmp71_;
	gint _tmp72_;
	gint _tmp73_;
	GDateTime* _tmp74_;
	GError * _inner_error_ = NULL;
	_tmp0_ = str;
	if (_tmp0_ == NULL) {
		result = NULL;
		return result;
	}
	{
		GRegex* _tmp1_ = NULL;
		GRegex* _tmp2_;
		GRegex* _tmp3_;
		_tmp2_ = g_regex_new ("\n" \
"\t\t\t\t# We don't care about the day of the week\n" \
"\t\t\t\t\\s*(?:(?:Mon|Tue|Wed|Thu|Fri|Sat|Sun),\\s*)?\n" \
"\t\t\t\t(?<day>\\d{1,2})\\s+\n" \
"\t\t\t\t(?<month>Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)\\s+\n" \
"\t\t\t\t# The standard specifies 2-digit years but 4 digit years are\n" \
"\t\t\t\t# recommended now.\n" \
"\t\t\t\t# This pattern will also accept 3-digit years, so we'll have t" \
"o\n" \
"\t\t\t\t# check for that separately\n" \
"\t\t\t\t(?<year>\\d{2,4})\\s+\n" \
"\t\t\t\t(?<hour>\\d{2})\n" \
"\t\t\t\t:(?<minute>\\d{2})\n" \
"\t\t\t\t(?::(?<second>\\d{2}))?\\s+\n" \
"\t\t\t\t(?<zone>UT|GMT|EST|EDT|MST|MDT|PST|PDT|[A-Z]|(?:[+-]\\d{4}))\n" \
"\t\t\t\t", G_REGEX_CASELESS | G_REGEX_EXTENDED, G_REGEX_MATCH_ANCHORED, &_inner_error_);
		_tmp1_ = _tmp2_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch7_g_regex_error;
			}
			_g_regex_unref0 (re);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp3_ = _tmp1_;
		_tmp1_ = NULL;
		_g_regex_unref0 (re);
		re = _tmp3_;
		_g_regex_unref0 (_tmp1_);
	}
	goto __finally7;
	__catch7_g_regex_error:
	{
		GError* e = NULL;
		FILE* _tmp4_;
		GError* _tmp5_;
		const gchar* _tmp6_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp4_ = stderr;
		_tmp5_ = e;
		_tmp6_ = _tmp5_->message;
		fprintf (_tmp4_, "RFC822 regex failed to parse: %s\n", _tmp6_);
		_vala_assert (FALSE, "false");
		result = NULL;
		_g_error_free0 (e);
		_g_regex_unref0 (re);
		return result;
	}
	__finally7:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_regex_unref0 (re);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp7_ = re;
	_tmp8_ = str;
	_tmp10_ = g_regex_match (_tmp7_, _tmp8_, 0, &_tmp9_);
	_g_match_info_unref0 (info);
	info = _tmp9_;
	if (!_tmp10_) {
		result = NULL;
		_g_match_info_unref0 (info);
		_g_regex_unref0 (re);
		return result;
	}
	_tmp11_ = info;
	_tmp12_ = g_match_info_fetch_named (_tmp11_, "day");
	dayStr = _tmp12_;
	_tmp13_ = dayStr;
	_tmp14_ = atoi (_tmp13_);
	day = _tmp14_;
	_tmp15_ = info;
	_tmp16_ = g_match_info_fetch_named (_tmp15_, "month");
	_tmp17_ = _tmp16_;
	_tmp18_ = g_ascii_strdown (_tmp17_, (gssize) -1);
	_tmp19_ = _tmp18_;
	_g_free0 (_tmp17_);
	monthStr = _tmp19_;
	_tmp20_ = monthStr;
	_tmp21_ = _tmp20_;
	_tmp23_ = (NULL == _tmp21_) ? 0 : g_quark_from_string (_tmp21_);
	if (_tmp23_ == ((0 != _tmp22_label0) ? _tmp22_label0 : (_tmp22_label0 = g_quark_from_static_string ("jan")))) {
		switch (0) {
			default:
			{
				month = 1;
				break;
			}
		}
	} else if (_tmp23_ == ((0 != _tmp22_label1) ? _tmp22_label1 : (_tmp22_label1 = g_quark_from_static_string ("feb")))) {
		switch (0) {
			default:
			{
				month = 2;
				break;
			}
		}
	} else if (_tmp23_ == ((0 != _tmp22_label2) ? _tmp22_label2 : (_tmp22_label2 = g_quark_from_static_string ("mar")))) {
		switch (0) {
			default:
			{
				month = 3;
				break;
			}
		}
	} else if (_tmp23_ == ((0 != _tmp22_label3) ? _tmp22_label3 : (_tmp22_label3 = g_quark_from_static_string ("apr")))) {
		switch (0) {
			default:
			{
				month = 4;
				break;
			}
		}
	} else if (_tmp23_ == ((0 != _tmp22_label4) ? _tmp22_label4 : (_tmp22_label4 = g_quark_from_static_string ("may")))) {
		switch (0) {
			default:
			{
				month = 5;
				break;
			}
		}
	} else if (_tmp23_ == ((0 != _tmp22_label5) ? _tmp22_label5 : (_tmp22_label5 = g_quark_from_static_string ("jun")))) {
		switch (0) {
			default:
			{
				month = 6;
				break;
			}
		}
	} else if (_tmp23_ == ((0 != _tmp22_label6) ? _tmp22_label6 : (_tmp22_label6 = g_quark_from_static_string ("jul")))) {
		switch (0) {
			default:
			{
				month = 7;
				break;
			}
		}
	} else if (_tmp23_ == ((0 != _tmp22_label7) ? _tmp22_label7 : (_tmp22_label7 = g_quark_from_static_string ("aug")))) {
		switch (0) {
			default:
			{
				month = 8;
				break;
			}
		}
	} else if (_tmp23_ == ((0 != _tmp22_label8) ? _tmp22_label8 : (_tmp22_label8 = g_quark_from_static_string ("sep")))) {
		switch (0) {
			default:
			{
				month = 9;
				break;
			}
		}
	} else if (_tmp23_ == ((0 != _tmp22_label9) ? _tmp22_label9 : (_tmp22_label9 = g_quark_from_static_string ("oct")))) {
		switch (0) {
			default:
			{
				month = 10;
				break;
			}
		}
	} else if (_tmp23_ == ((0 != _tmp22_label10) ? _tmp22_label10 : (_tmp22_label10 = g_quark_from_static_string ("nov")))) {
		switch (0) {
			default:
			{
				month = 11;
				break;
			}
		}
	} else if (_tmp23_ == ((0 != _tmp22_label11) ? _tmp22_label11 : (_tmp22_label11 = g_quark_from_static_string ("dec")))) {
		switch (0) {
			default:
			{
				month = 12;
				break;
			}
		}
	} else {
		switch (0) {
			default:
			{
				_vala_assert (FALSE, "false");
				result = NULL;
				_g_free0 (monthStr);
				_g_free0 (dayStr);
				_g_match_info_unref0 (info);
				_g_regex_unref0 (re);
				return result;
			}
		}
	}
	_tmp24_ = info;
	_tmp25_ = g_match_info_fetch_named (_tmp24_, "year");
	yearStr = _tmp25_;
	_tmp26_ = yearStr;
	_tmp27_ = atoi (_tmp26_);
	year = _tmp27_;
	_tmp29_ = year;
	if (_tmp29_ >= 0) {
		gint _tmp30_;
		_tmp30_ = year;
		_tmp28_ = _tmp30_ <= 49;
	} else {
		_tmp28_ = FALSE;
	}
	if (_tmp28_) {
		gint _tmp31_;
		_tmp31_ = year;
		year = _tmp31_ + 2000;
	} else {
		gboolean _tmp32_ = FALSE;
		gint _tmp33_;
		_tmp33_ = year;
		if (_tmp33_ >= 50) {
			gint _tmp34_;
			_tmp34_ = year;
			_tmp32_ = _tmp34_ < 100;
		} else {
			_tmp32_ = FALSE;
		}
		if (_tmp32_) {
			gint _tmp35_;
			_tmp35_ = year;
			year = _tmp35_ + 1900;
		}
	}
	_tmp36_ = info;
	_tmp37_ = g_match_info_fetch_named (_tmp36_, "hour");
	hourStr = _tmp37_;
	_tmp38_ = hourStr;
	_tmp39_ = atoi (_tmp38_);
	hour = _tmp39_;
	_tmp40_ = info;
	_tmp41_ = g_match_info_fetch_named (_tmp40_, "minute");
	minuteStr = _tmp41_;
	_tmp42_ = minuteStr;
	_tmp43_ = atoi (_tmp42_);
	minute = _tmp43_;
	_tmp44_ = info;
	_tmp45_ = g_match_info_fetch_named (_tmp44_, "second");
	secondStr = _tmp45_;
	_tmp48_ = secondStr;
	if (_tmp48_ == NULL) {
		_tmp47_ = TRUE;
	} else {
		const gchar* _tmp49_;
		_tmp49_ = secondStr;
		_tmp47_ = g_strcmp0 (_tmp49_, "") == 0;
	}
	if (_tmp47_) {
		_tmp46_ = 0;
	} else {
		const gchar* _tmp50_;
		gint _tmp51_;
		_tmp50_ = secondStr;
		_tmp51_ = atoi (_tmp50_);
		_tmp46_ = _tmp51_;
	}
	second = _tmp46_;
	_tmp52_ = info;
	_tmp53_ = g_match_info_fetch_named (_tmp52_, "zone");
	zoneStr = _tmp53_;
	_tmp54_ = zoneStr;
	_tmp55_ = g_ascii_strup (_tmp54_, (gssize) -1);
	_tmp56_ = _tmp55_;
	_tmp58_ = (NULL == _tmp56_) ? 0 : g_quark_from_string (_tmp56_);
	g_free (_tmp56_);
	if (_tmp58_ == ((0 != _tmp57_label0) ? _tmp57_label0 : (_tmp57_label0 = g_quark_from_static_string ("EDT")))) {
		switch (0) {
			default:
			{
				GTimeZone* _tmp59_;
				_tmp59_ = g_time_zone_new ("-04");
				_g_time_zone_unref0 (zone);
				zone = _tmp59_;
				break;
			}
		}
	} else if ((_tmp58_ == ((0 != _tmp57_label1) ? _tmp57_label1 : (_tmp57_label1 = g_quark_from_static_string ("CDT")))) || (_tmp58_ == ((0 != _tmp57_label2) ? _tmp57_label2 : (_tmp57_label2 = g_quark_from_static_string ("EST"))))) {
		switch (0) {
			default:
			{
				GTimeZone* _tmp60_;
				_tmp60_ = g_time_zone_new ("-05");
				_g_time_zone_unref0 (zone);
				zone = _tmp60_;
				break;
			}
		}
	} else if ((_tmp58_ == ((0 != _tmp57_label3) ? _tmp57_label3 : (_tmp57_label3 = g_quark_from_static_string ("CST")))) || (_tmp58_ == ((0 != _tmp57_label4) ? _tmp57_label4 : (_tmp57_label4 = g_quark_from_static_string ("MDT"))))) {
		switch (0) {
			default:
			{
				GTimeZone* _tmp61_;
				_tmp61_ = g_time_zone_new ("-06");
				_g_time_zone_unref0 (zone);
				zone = _tmp61_;
				break;
			}
		}
	} else if ((_tmp58_ == ((0 != _tmp57_label5) ? _tmp57_label5 : (_tmp57_label5 = g_quark_from_static_string ("MST")))) || (_tmp58_ == ((0 != _tmp57_label6) ? _tmp57_label6 : (_tmp57_label6 = g_quark_from_static_string ("PDT"))))) {
		switch (0) {
			default:
			{
				GTimeZone* _tmp62_;
				_tmp62_ = g_time_zone_new ("-07");
				_g_time_zone_unref0 (zone);
				zone = _tmp62_;
				break;
			}
		}
	} else if (_tmp58_ == ((0 != _tmp57_label7) ? _tmp57_label7 : (_tmp57_label7 = g_quark_from_static_string ("PST")))) {
		switch (0) {
			default:
			{
				GTimeZone* _tmp63_;
				_tmp63_ = g_time_zone_new ("-08");
				_g_time_zone_unref0 (zone);
				zone = _tmp63_;
				break;
			}
		}
	} else if (((_tmp58_ == ((0 != _tmp57_label8) ? _tmp57_label8 : (_tmp57_label8 = g_quark_from_static_string ("GMT")))) || (_tmp58_ == ((0 != _tmp57_label9) ? _tmp57_label9 : (_tmp57_label9 = g_quark_from_static_string ("UT"))))) || (_tmp58_ == ((0 != _tmp57_label10) ? _tmp57_label10 : (_tmp57_label10 = g_quark_from_static_string ("Z"))))) {
		switch (0) {
			default:
			{
				GTimeZone* _tmp64_;
				_tmp64_ = g_time_zone_new_utc ();
				_g_time_zone_unref0 (zone);
				zone = _tmp64_;
				break;
			}
		}
	} else {
		switch (0) {
			default:
			{
				const gchar* _tmp65_;
				GTimeZone* _tmp66_;
				_tmp65_ = zoneStr;
				_tmp66_ = g_time_zone_new (_tmp65_);
				_g_time_zone_unref0 (zone);
				zone = _tmp66_;
				break;
			}
		}
	}
	_tmp67_ = zone;
	_tmp68_ = year;
	_tmp69_ = month;
	_tmp70_ = day;
	_tmp71_ = hour;
	_tmp72_ = minute;
	_tmp73_ = second;
	_tmp74_ = g_date_time_new (_tmp67_, _tmp68_, _tmp69_, _tmp70_, _tmp71_, _tmp72_, (gdouble) _tmp73_);
	result = _tmp74_;
	_g_time_zone_unref0 (zone);
	_g_free0 (zoneStr);
	_g_free0 (secondStr);
	_g_free0 (minuteStr);
	_g_free0 (hourStr);
	_g_free0 (yearStr);
	_g_free0 (monthStr);
	_g_free0 (dayStr);
	_g_match_info_unref0 (info);
	_g_regex_unref0 (re);
	return result;
}



